SystemOrganization addCategory: #'TKSave-Apps'!
SystemOrganization addCategory: #'TKSave-Base'!
SystemOrganization addCategory: #'TKSave-Tests'!
SystemOrganization addCategory: #'TKSave-Connection'!

!String methodsFor: '*tksave' stamp: 'tk 5/15/2008 15:45'!
asDescriptionSelector
	| selector |
	selector := self copy.
	selector at: 1 put: (((self at: 1) asUppercase)).
	^('description',selector) asSymbol.! !

!String methodsFor: '*tksave' stamp: 'tk 6/19/2008 15:30'!
asSqSaveDescriptionSelector
	| selector |
	selector := self copy.
	selector at: 1 put: (((self at: 1) asUppercase)).
	^('persistenceDescription',selector) asSymbol.! !

!String methodsFor: '*tksave' stamp: 'tk 7/7/2008 15:19'!
asSqSaveTableName
	| |
	^self decamelized,'s'! !

!String methodsFor: '*tksave' stamp: 'tk 7/7/2008 15:19'!
decamelized
	| result nextChar |
	result := WriteStream on: String new.
	self withIndexDo: [:char :index |
		nextChar := self at: (index + 1) ifAbsent: [$t].
		(((nextChar isLowercase) and: [char isUppercase]) and:[index > 1]) ifTrue: [
			result nextPutAll: '_'.
		].
		result nextPutAll: char asLowercase asString.
	].
	^result contents! !

!String methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:46'!
magritteDescriptionClass
	^#MAStringDescription! !

!String methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:50'!
magritteDescriptionDefaultValue
	^''''''! !

!JdmConnection methodsFor: '*tksave' stamp: 'tk 7/18/2008 16:02'!
socket
	^socket! !

ProtoObject subclass: #SqSProxy
	instanceVariableNames: 'proxiedObject proxyOwner proxiedVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

SqSProxy subclass: #SqSCollectionProxy
	instanceVariableNames: 'collectionMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSCollectionProxy methodsFor: 'accessing' stamp: 'tk 8/29/2008 17:16'!
getCollectionChanges
	| counter changes newCollectionMap |
	counter := 0.
	newCollectionMap := self sqSaveCreateCollectionMap.
	changes := Dictionary newFrom: {#added->OrderedCollection new. #deleted->OrderedCollection new. #moved->OrderedCollection new}.
	
	collectionMap ifNil: [^changes].
	collectionMap do: [:oid |
		| newOid |
		counter := counter + 1.
		(counter > newCollectionMap size) ifTrue: [
			(changes at: #deleted) add: (OrderedCollection with: oid with: counter) 
		] ifFalse: [
			newOid := newCollectionMap at: counter.
			(newOid ~= oid) ifTrue: [
				(changes at: #moved) add: (OrderedCollection with: newOid with: counter) 		
			]
		]				
	].
	[counter < newCollectionMap size] whileTrue: [
		counter := counter + 1.
		(changes at: #added) add: (OrderedCollection with: (newCollectionMap at: counter) with: counter).
	].
	collectionMap := newCollectionMap.
	^changes! !

!SqSCollectionProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 10:48'!
proxiedObject: anObject 
	super proxiedObject: anObject.
	"only update the map when there is not already one present"
	collectionMap ifNil: [ collectionMap := self sqSaveCreateCollectionMap ]! !

!SqSCollectionProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 11:09'!
sqSaveClass
	^ self proxiedObject class! !

!SqSCollectionProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 10:38'!
sqSaveCreateCollectionMap
	| tmpMap |
	proxiedObject ifNotNil: [
		tmpMap := OrderedCollection new.
		proxiedObject do: [:obj | 
			tmpMap add: (obj ifNil: [nil] ifNotNil: [obj oid])
		]
	].
	^tmpMap
	! !

!SqSProxy class methodsFor: 'as yet unclassified' stamp: 'tk 9/1/2008 10:50'!
for: aCollection ofInstVar: anIvarName in: anObject 
	^ self new
		proxyOwner: anObject;
		proxiedObject: aCollection;
		proxiedVariable: anIvarName! !

!SqSProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 11:07'!
doesNotUnderstand: aMessage 
	"TODO: handling for fancy load strategies here"
	self proxiedObject ifNil: 
		[ self proxiedObject: (self proxyOwner loadProxiedObjectOfVariable: self proxiedVariable) ].
	"TODO: implement some sort of access loggin here"
	^ aMessage sendTo: self proxiedObject! !

!SqSProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 10:49'!
proxiedObject
	^ proxiedObject! !

!SqSProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 10:49'!
proxiedObject: anObject
	proxiedObject := anObject! !

!SqSProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 11:07'!
proxiedVariable
	^ proxiedVariable! !

!SqSProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 11:07'!
proxiedVariable: anObject
	proxiedVariable := anObject.! !

!SqSProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 11:07'!
proxyOwner
	^ proxyOwner! !

!SqSProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 11:07'!
proxyOwner: anObject
	proxyOwner := anObject! !

!SqSProxy methodsFor: 'accessing' stamp: 'tk 9/1/2008 11:07'!
sqSaveClass
	^ self proxiedObject class! !

!Collection methodsFor: '*tksave' stamp: 'tk 7/14/2008 19:02'!
join: joinString
	| joiner |
	joiner := joinString ifNil:[''] ifNotNil: [joinString].
	^String streamContents: [:s | self asStringOn: s delimiter: joiner]! !

TestCase subclass: #SqSaveBaseTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveBaseTest methodsFor: 'private' stamp: 'tk 7/21/2008 11:47'!
clearDatabase
	connection resetDatabase! !

!SqSaveBaseTest methodsFor: 'private' stamp: 'tk 7/4/2008 17:36'!
removeDescriptions
	| classes |
	classes := Set with: SqSaveTestObject.
	classes addAll: SqSaveTestObject allSubclasses.
	classes do: [ :curClass |
		curClass allInstVarNames do: [ :ivn | 
			(curClass class includesSelector: ivn asDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asDescriptionSelector
			].
			(curClass class includesSelector: ivn asSqSaveDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asSqSaveDescriptionSelector
			].
		]
	].! !

!SqSaveBaseTest methodsFor: 'private' stamp: 'tkow 9/2/2008 16:23'!
setUp
	SqSConnectionManager getInstance setupTestConnection.
	connection := SqSConnectionManager getInstance getConnectionForCategory: SqSConnectionManager testCategory! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 7/31/2008 16:26'!
testGetDirectlyReferencedObjects
	| testObject testObject2 directlyReferencedObjects |
	self removeDescriptions.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	
	testObject testInteger: 4.
	testObject testSomething: testObject2.
	
	testObject descriptionHandler createDescriptionMethods.
	
	directlyReferencedObjects := testObject directlyReferencedObjects.
	self assert: directlyReferencedObjects size == 1.
	self assert: directlyReferencedObjects first == testObject2.
	! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tkow 9/2/2008 16:18'!
testGetIndirectlyReferencedObjects
	| testObject testObject2 indirectlyReferencedObjects |
	self removeDescriptions.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	testObject testInteger: 4.
	testObject testSomething: (OrderedCollection with: testObject2).
	testObject descriptionHandler createDescriptionMethods.
	indirectlyReferencedObjects := testObject indirectlyReferencedObjects.
	self assert: indirectlyReferencedObjects size == 1.
	self assert: (indirectlyReferencedObjects first at: #collection) first == testObject2.
	self assert: (indirectlyReferencedObjects first at: #description) class = SqSCollectionDescription! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 7/7/2008 17:07'!
testGetPersistedInstanceVariables
	| |
	self assert: SqSaveTestObject persistedInstVars size = 4.
	self assert: SqSaveTestObject persistedInstVars size < SqSaveTestObjectChild persistedInstVars size.
	self assert: (SqSaveTestObjectChild persistedInstVars includes: 'testUnstoredVariable') not.
	self assert: (SqSaveTestObjectChild persistedInstVars includes: 'oid') not.! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:53'!
testNewRecordAttribute
	| obj obj2 |
	obj := SqSaveTestObject new.
	obj testInteger: 42.
	self assert: obj newRecord.
	obj save.
	self assert: obj newRecord not.
	obj2 := SqSaveTestObject findByTestInteger: 42.
	self assert: obj2 newRecord not! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:53'!
testObjectIdAssignment
	| testObject testObject2 |
	self clearDatabase.
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	self assert: testObject oid == 1.
	testObject2 := SqSaveTestObject new.
	testObject2 testInteger: 4.
	testObject2 save.
	self assert: testObject2 oid == 2! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tkow 9/2/2008 16:19'!
testPersistenceDescriptorCreationOnSave
	| testObject description |
	self removeDescriptions.
	self clearDatabase.
	testObject := SqSaveTestObject new.
	testObject
		testDate: Date today;
		testInteger: 42;
		testString: 'calculon';
		testSomething: SqSaveTestObject new.
	testObject save.
	description := SqSaveTestObject persistenceDescriptionTestInteger.
	self assert: description class = SqSColumnDescription.
	self assert: description sqlType = 'SMALLINT'.
	self assert: description columnName = 'test_integer'.
	self assert: description associatedClass isNil.
	self assert: description tableName = SqSaveTestObject name asSqSaveTableName! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 7/7/2008 17:19'!
testPersistenceDescriptorCreationOnSaveHappensOnlyInTheClassesDefiningTheVariable
	| testObject |
	self removeDescriptions.
	self clearDatabase.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject testSubString: 'test'.
	testObject testExtremelyDeepSubString: 'test'. 
	testObject save.
	self assert: (SqSaveTestObject class includesSelector: 'testDate' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testInteger' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testString' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testSomething' asSqSaveDescriptionSelector) not.
	self assert: (SqSaveTestObjectChild class includesSelector: 'testSubString' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObjectEvenDeeperChild class includesSelector: 'testExtremelyDeepSubString' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testSubString' asSqSaveDescriptionSelector) not.
	self assert: (SqSaveTestObject class includesSelector: 'testExtremelyDeepSubString' asSqSaveDescriptionSelector) not.
	
	! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:53'!
testTableCreationOnSave
	| testObject |
	self clearDatabase.
	self assert: SqSaveTestObject tableForClassExists not.
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	self assert: SqSaveTestObject tableForClassExists! !

TestCase subclass: #SqSaveBaseWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveBaseWrapperTest methodsFor: 'tests' stamp: 'tkow 9/2/2008 16:19'!
testAdditionalTableColumns
	| testObject oldColumns testWrapper testDescription newColumns |
	testObject := SqSaveTestObject new
		testString: 'test';
		testInteger: 42;
		testSomething: 'test2';
		testDate: Date today.
	SqSaveTestObject createClassDescriptionFor: testObject.
	oldColumns := testObject allClassTableColumns.
	testWrapper := SqSBaseWrapper for: testObject.
	testDescription := SqSColumnDescription new.
	testWrapper 
		addInstVarNamed: 'testObjectId'
		withValue: 42
		andDescription: testDescription.
	newColumns := testWrapper allClassTableColumns.
	self assert: newColumns keys size == (oldColumns keys size + 1).
	self assert: (newColumns includesKey: 'testObjectId').
	self assert: (newColumns at: 'testObjectId') isNil not! !

!SqSaveBaseWrapperTest methodsFor: 'tests' stamp: 'tk 9/2/2008 15:19'!
testAttributeAccessing
	| testObject testWrapper |
	testObject := SqSaveTestObject new.
	testWrapper := SqSBaseWrapper for: testObject.
	testWrapper 
		addInstVarNamed: 'testObjectId'
		withValue: 42.
	self 
		shouldnt: [ testWrapper testObjectId ]
		raise: Error.
	self assert: testWrapper testObjectId == 42.
	self 
		shouldnt: [ testWrapper testObjectId: 21 ]
		raise: Error.
	self assert: testWrapper testObjectId == 21! !

!SqSaveBaseWrapperTest methodsFor: 'tests' stamp: 'tk 9/2/2008 15:19'!
testCreationIsOnlyForSqSaveBaseObjects
	| testObject testWrapper |
	self 
		should: [ SqSBaseWrapper for: 42 ]
		raise: Error.
	testObject := SqSaveTestObject new.
	self 
		shouldnt: [ SqSBaseWrapper for: testObject ]
		raise: Error.
	testWrapper := SqSBaseWrapper for: testObject.
	self assert: testWrapper baseObject == testObject! !

TestCase subclass: #SqSaveCollectionTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveCollectionTest methodsFor: 'private' stamp: 'tk 8/25/2008 17:47'!
clearDatabase
	connection resetDatabase! !

!SqSaveCollectionTest methodsFor: 'private' stamp: 'tk 8/25/2008 10:40'!
removeDescriptions
	| classes |
	classes := Set with: SqSaveTestObject.
	classes addAll: SqSaveTestObject allSubclasses.
	classes do: [ :curClass |
		curClass allInstVarNames do: [ :ivn | 
			(curClass class includesSelector: ivn asDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asDescriptionSelector
			].
			(curClass class includesSelector: ivn asSqSaveDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asSqSaveDescriptionSelector
			].
		]
	].! !

!SqSaveCollectionTest methodsFor: 'private' stamp: 'tkow 9/2/2008 16:23'!
setUp
	SqSConnectionManager getInstance setupTestConnection.
	connection := SqSConnectionManager getInstance getConnectionForCategory: SqSConnectionManager testCategory! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tk 8/29/2008 17:05'!
testCollectionAdding
	| testObject2 testObject1 testResult testObject3 testResult2 |
	self removeDescriptions.
	self clearDatabase.	
	testObject2 := SqSaveTestObject new
		testInteger: 42;
		yourself.

	"this should also lead to a removal of the testSomething column...."
	testObject1 := SqSaveTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
		
	testObject1 save.
	
	testResult := SqSaveTestObject findByTestInteger: 21.
	self assert: (testResult isNil not).
	self assert: (testResult testSomething isCollection).
	self assert: ((testResult testSomething at: 1) = testObject2).
	
	testObject3 := SqSaveTestObject new
		testInteger: 42;
		yourself.
 
	testResult testSomething add: testObject3.
	testResult save.
	
	testResult2 := SqSaveTestObject findByTestInteger: 21.
	self assert: (testResult2 isNil not).
	self assert: (testResult2 testSomething isCollection).
	self assert: ((testResult2 testSomething at: 1) = testObject2).
	self shouldnt: [testResult2 testSomething at: 2] raise: Error.
	self assert: (testResult2 testSomething at: 2) = testObject3.
	
! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tk 8/29/2008 16:10'!
testCollectionRemoving
	| testObject2 testObject1 testResult testObject3 |
	self removeDescriptions.
	self clearDatabase.	
	
	testObject2 := SqSaveTestObject new
		testInteger: 42;
		yourself.

	testObject1 := SqSaveTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
		
	testObject3 := SqSaveTestObject new
		testInteger: 42;
		yourself.
 
	testObject1 testSomething add: testObject3.
	testObject1 save.
	
	testObject1 testSomething removeAt: 2.	
	testObject1 save.
	
	testResult := SqSaveTestObject findByTestInteger: 21.
	self assert: (testResult isNil not).
	self assert: (testResult testSomething isCollection).
	self assert: ((testResult testSomething at: 1) = testObject2).
	self should: [testResult testSomething at: 2] raise: Error.
	
! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tk 8/29/2008 17:17'!
testCollectionShuffling
	| testObject2 testObject1 testResult testObject3 |
	self removeDescriptions.
	self clearDatabase.
	testObject2 := SqSaveTestObject new testInteger: 42.
	testObject1 := SqSaveTestObject new testInteger: 21;
				testSomething: (OrderedCollection with: testObject2).
	testObject3 := SqSaveTestObject new testInteger: 42.
	
	testObject1 testSomething add: testObject3.
	testObject1 save.
	testObject1 testSomething: testObject1 testSomething reversed.
	testObject1 save.
	testResult := SqSaveTestObject findByTestInteger: 21.
	self assert: testResult isNil not.
	self assert: testResult testSomething isCollection.
	self assert: (testResult testSomething at: 1)
			= testObject3.
	self assert: (testResult testSomething at: 2)
			= testObject2! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tk 8/26/2008 17:52'!
testDescriptionCreation
	| testObject testObject2 description referenceColumn ownerColumn |
	self removeDescriptions.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	
	testObject testInteger: 4.
	testObject testSomething: (OrderedCollection with: testObject2).
	
	testObject descriptionHandler createDescriptionMethods.
	
	description := nil.
	self shouldnt: [description := SqSaveTestObjectEvenDeeperChild persistenceDescriptionTestSomething] raise: Error.
	self assert: description isNil not.
	self assert: description describesCollection.
	self assert: description joinTableName = 'sq_save_test_objects_test_something'.
	referenceColumn := description referenceColumn.
	self assert: referenceColumn columnName = 'test_something_id'.
	self assert: description referenceTableName = 'sq_save_test_objects'.
	ownerColumn := description ownerColumn.
	self assert: ownerColumn columnName = 'sq_save_test_object_id'.! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tk 9/1/2008 11:55'!
testNilObjectsInCollections
	| testObject2 testObject1 testResult testObject3 |
	self removeDescriptions.
	self clearDatabase.	
	
	testObject2 := SqSaveTestObject new
		testInteger: 42;
		yourself.

	testObject1 := SqSaveTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
		
	testObject3 := SqSaveTestObject new
		testInteger: 42;
		yourself.
 
	testObject1 testSomething add: nil.
	testObject1 testSomething add: nil.
	testObject1 testSomething add: testObject3.
	testObject1 testSomething add: nil.
	
	testObject1 save.
	
	testResult := SqSaveTestObject findByTestInteger: 21.
	self assert: (testResult isNil not).
	self assert: (testResult testSomething isCollection).
	self assert: ((testResult testSomething at: 1) = testObject2).
	self shouldnt: [testResult testSomething at: 2] raise: Error.
	self assert: (testResult testSomething size = 5).
	self assert: ((testResult at: 2) isNil)
	
! !

TestCase subclass: #SqSaveColumnTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveColumnTest methodsFor: 'tests' stamp: 'tkow 9/2/2008 16:19'!
testCreationCode
	| column column2 |
	column := SqSColumnDescription new.
	column columnName: 'testColumn'.
	column sqlType: 'INTEGER'.
	column2 := Compiler evaluate: column creationCode.
	self assert: column2 class = SqSColumnDescription.
	self assert: column2 sqlType = 'INTEGER'.
	self assert: column2 columnName = 'testColumn'! !

TestCase subclass: #SqSaveConnectionManagerTest
	instanceVariableNames: 'connectionManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveConnectionManagerTest methodsFor: 'running' stamp: 'tkow 9/2/2008 16:23'!
setUp
	connectionManager := SqSConnectionManager getInstance! !

!SqSaveConnectionManagerTest methodsFor: 'tests' stamp: 'tkow 9/2/2008 16:24'!
testAddConnectionSpecification
	| connectionSpecification connection |
	connectionManager connectionSpecificationDictionary: Dictionary new.
	connectionSpecification := SqSConnectionSpecification 
		user: 'thomas'
		password: 'test'
		port: 3306
		database: 'squeak_test'
		hostname: 'localhost'
		driver: #SqSMySQLDriver.
	connectionManager 
		setupConnectionSpecification: connectionSpecification
		for: 'TKSave'.
	self assert: (connectionManager connectionSpecificationDictionary includesKey: 'TKSave').
	self assert: (connectionManager connectionSpecificationDictionary at: 'TKSave') class == SqSConnectionSpecification.
	connection := connectionManager getConnectionForCategory: 'TKSave'.
	self assert: connection isNil not! !

TestCase subclass: #SqSaveDescriptionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveDescriptionHandlerTest methodsFor: 'tests' stamp: 'tkow 9/2/2008 16:19'!
testSqlTypeRecognition
	| handler |
	handler := SqSDescriptionHandler for: SqSaveTestObject new.
	self assert: (handler determineSqlTypeForObject: 42) = 'SMALLINT'.
	self assert: (handler determineSqlTypeForObject: SqSaveTestObject new) = 'INTEGER'.
	self assert: (handler determineSqlTypeForObject: SqSColumnDescription new) isNil.
	self assert: (handler determineSqlTypeForObject: true) = 'BOOLEAN'! !

TestCase subclass: #SqSaveDictionaryExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveDictionaryExtensionTests methodsFor: 'tests' stamp: 'tk 8/15/2008 14:49'!
testValueJoin
	| dict1 dict2 result |
	dict1 := Dictionary new.
	dict1 at: #test1 put: (OrderedCollection with: 42).
	dict1 at: #test2 put: 42.
	dict1 at: #test3 put: (OrderedCollection with: 84).
	
	dict2 := Dictionary new.
	dict2 at: #test1 put: (OrderedCollection with: 21).
	dict2 at: #test2 put: 21.
	
	result := dict1 valueJoin: dict2.
	self assert: ((result at: #test1) isCollection).
	self assert: ((result at: #test1) includes: (42)).
	self assert: ((result at: #test1) includes: (21)).

	self assert: ((result at: #test2) isCollection).
	self assert: ((result at: #test2) includes: (42)).
	self assert: ((result at: #test2) includes: (21)).

	self assert: ((result at: #test3) isCollection).
	self assert: ((result at: #test3) includes: (84)).
	! !

TestCase subclass: #SqSaveInheritanceTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

SqSaveInheritanceTest subclass: #SqSaveClassTableInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveClassTableInheritanceTest methodsFor: 'running' stamp: 'tk 7/21/2008 11:50'!
setUp
	| code |
	super setUp.
	code := 'persistenceInheritanceMode',String cr,String tab, '^#classTableInheritance'.
	(SqSaveTestObject organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		SqSaveTestObject organization addCategory: (self descriptorMethodCategory).
	].
	SqSaveTestObject class compile: code classified: (self descriptorMethodCategory).! !

!SqSaveClassTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/2/2008 16:23'!
testCascadingDelete
	| dbConnection result testObject resultDicts oid |
	testObject := SqSaveTestObjectEvenDeeperChild new
		testString: 'Hello World';
		testInteger: 42;
		testSubString: 'SubString';
		testExtremelyDeepSubString: 'DeeperSubString'.
	testObject save.
	oid := testObject oid.
	testObject destroy.
	dbConnection := SqSConnectionManager getInstance getConnectionForCategory: 'TKSave'.
	result := dbConnection executeQuery: 'SELECT * FROM ' , SqSaveTestObjectChild name asSqSaveTableName , ' WHERE oid = ' , oid asString.
	resultDicts := OrderedCollection new.
	[ result next ] whileTrue: [ resultDicts add: result currentRowAsDictionary ].
	self assert: resultDicts isEmpty.
	result := dbConnection executeQuery: 'SELECT * FROM ' , SqSaveTestObjectEvenDeeperChild name asSqSaveTableName , ' WHERE oid = ' , oid asString.
	resultDicts := OrderedCollection new.
	[ result next ] whileTrue: [ resultDicts add: result currentRowAsDictionary ].
	self assert: resultDicts isEmpty! !

!SqSaveClassTableInheritanceTest methodsFor: 'tests' stamp: 'tk 7/14/2008 16:38'!
testGetClassTableColumns
	self assert: SqSaveTestObject allClassTableColumns keys size = 5.
	self assert: SqSaveTestObjectChild allClassTableColumns keys size = 1.
	self assert: SqSaveTestObjectEvenDeeperChild allClassTableColumns keys size = 1.! !

!SqSaveClassTableInheritanceTest methodsFor: 'tests' stamp: 'tk 6/30/2008 16:26'!
testTableNames
	self assert: SqSaveTestObject tableName = SqSaveTestObject name asSqSaveTableName.
	self assert: SqSaveTestObjectChild tableName = SqSaveTestObjectChild name asSqSaveTableName.
	self assert: SqSaveTestObjectEvenDeeperChild tableName = SqSaveTestObjectEvenDeeperChild name asSqSaveTableName.! !

!SqSaveInheritanceTest class methodsFor: 'as yet unclassified' stamp: 'tk 7/1/2008 13:08'!
shouldInheritSelectors
	^true! !

!SqSaveInheritanceTest methodsFor: 'private' stamp: 'tk 7/21/2008 11:48'!
clearDatabase
	connection resetDatabase! !

!SqSaveInheritanceTest methodsFor: 'private' stamp: 'tk 6/26/2008 18:05'!
descriptorMethodCategory
	^'persistence-description'! !

!SqSaveInheritanceTest methodsFor: 'private' stamp: 'tk 8/12/2008 13:41'!
removeDescriptions
	| classes |
	classes := Set with: SqSaveTestObject.
	classes addAll: SqSaveTestObject allSubclasses.
	classes do: [ :curClass |
		curClass allInstVarNames do: [ :ivn | 
			(curClass class includesSelector: ivn asDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asDescriptionSelector
			].
			(curClass class includesSelector: ivn asSqSaveDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asSqSaveDescriptionSelector
			].
		]
	].! !

!SqSaveInheritanceTest methodsFor: 'running' stamp: 'tkow 9/2/2008 16:23'!
setUp
	connection := SqSConnectionManager getInstance getConnectionForCategory: 'TKSave'.
	self clearDatabase.
	self removeDescriptions! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/2/2008 16:20'!
testComplexCollectionStorage
	| testObject testObject2 testResult |
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	testObject testSomething: (OrderedCollection with: testObject2).
	testObject testInteger: 42.
	testObject save.
	testResult := SqSaveTestObject findByTestInteger: 42.
	self assert: testObject = testResult.
	self assert: testResult testSomething class = SqSCollectionProxy.
	self assert: testResult testSomething first = testObject2! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:44'!
testCorrectObjectCreation
	| testObject1 testObject2 result |
	testObject1 := SqSaveTestObject new.
	testObject1 testInteger: 42.
	testObject1 save.
	result := SqSaveTestObject findByTestInteger: 42.
	self assert: result class = SqSaveTestObject.
	testObject2 := SqSaveTestObjectChild new.
	testObject2 testInteger: 21.
	testObject2 save.
	result := SqSaveTestObject findByTestInteger: 21.
	self assert: result class = SqSaveTestObjectChild! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:44'!
testDestroyObjects
	| testObject searchResult newSearchResult |
	testObject := (SqSaveTestObjectEvenDeeperChild new)
		testString: 'Hello World';
		testInteger: 42;
		testSubString: 'SubString';
		testExtremelyDeepSubString: 'DeeperSubString'.
	testObject save.
	searchResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: (searchResult isNil not).
	searchResult destroy.
	newSearchResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: (newSearchResult isNil).! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 7/8/2008 16:32'!
testGetPersistedInstanceVariables
	| |
	self assert: SqSaveTestObject persistedInstVars size = 4.
	self assert: SqSaveTestObjectChild persistedInstVars size = 5.
	self assert: SqSaveTestObjectEvenDeeperChild persistedInstVars size = 6.	
	self assert: SqSaveTestObject persistedInstVars size < SqSaveTestObjectChild persistedInstVars size.
	self assert: (SqSaveTestObjectChild persistedInstVars includes: 'testUnstoredVariable') not.
	self assert: (SqSaveTestObjectChild persistedInstVars includes: 'oid') not.! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:45'!
testNamingBasedSearch
	| testObject searchResult1 searchResult2 searchResult3 searchResult0 |
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	searchResult0 := SqSaveTestObject 
		findByTestInteger: 5
		andTestDate: Date today.
	searchResult1 := SqSaveTestObject findByTestInteger: 5.
	searchResult2 := SqSaveTestObject 
		findByTestDate: Date today
		andTestString: 'test'.
	searchResult3 := SqSaveTestObject findByTestString: 'test'.
	self assert: searchResult0 isNil not.
	self assert: searchResult0 testInteger = 5.
	self assert: searchResult0 testDate = Date today.
	self assert: searchResult0 testString = 'test'.
	self assert: testObject = searchResult1.
	self assert: testObject = searchResult2.
	self assert: testObject = searchResult3! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:44'!
testObjectCompleteness
	| testObject testResult |
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testInteger: 42;
		testString: 'fortyTwo';
		testDate: Date today;
		testSomething: 3;
		testSubString: 'twentyOne';
		testExtremelyDeepSubString: 'elevenAndAHalf'.
	testObject save.
	testResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: (testResult isNil not).
	self assert: (testResult testInteger =  42).
	self assert: (testResult testString = 'fortyTwo').
	self assert: (testResult testDate = Date today).
	self assert: (testResult testSomething = 3).
	self assert: (testResult testSubString = 'twentyOne').
	self assert: (testResult testExtremelyDeepSubString = 'elevenAndAHalf').

	! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 15:23'!
testSaveRelatedObjectAlongWithObject
	| testObject testObject2 result |
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject2 := SqSaveTestObject new.
	testObject2 testInteger: 6.
	testObject2 testString: 'test2'.
	testObject testSomething: testObject2.
	self assert: testObject2 newRecord.
	testObject save.
	self assert: testObject2 newRecord not.
	self assert: testObject2 oid isNil not.
	result := SqSaveTestObject findByTestInteger: 6.
	self assert: result = testObject2! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 7/1/2008 13:07'!
testSomething
	self assert: true.! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:45'!
testUpdate
	| testObject testResult |
	testObject := (SqSaveTestObjectEvenDeeperChild new)
		testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 3.14;
		testSubString: 'subString';
		testExtremelyDeepSubString: 'deepSubString'.
	testObject save.
		
	testObject testString: 'newTest'.
	testObject save.
	
	testResult := SqSaveTestObject findByTestInteger: 42.
	self assert: testResult isNil not.
	self assert: (testResult testString = 'newTest').! !

SqSaveInheritanceTest subclass: #SqSaveSingleTableInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveSingleTableInheritanceTest methodsFor: 'running' stamp: 'tk 7/21/2008 11:51'!
setUp
	| code |
	super setUp.
	code := 'persistenceInheritanceMode',String cr,String tab, '^#singleTableInheritance'.
	(SqSaveTestObject organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		SqSaveTestObject organization addCategory: (self descriptorMethodCategory).
	].
	SqSaveTestObject class compile: code classified: (self descriptorMethodCategory).! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tk 7/7/2008 17:17'!
testGetClassTableColumns
	self assert: SqSaveTestObject allClassTableColumns keys = SqSaveTestObjectChild allClassTableColumns keys.
	self assert: SqSaveTestObject allClassTableColumns keys = SqSaveTestObjectEvenDeeperChild allClassTableColumns keys.! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:46'!
testSaveSubclassWithSingleTableInheritance
	| testObject |
	self assert: SqSaveTestObjectChild tableName = SqSaveTestObject name asSqSaveTableName.
	self assert: SqSaveTestObjectChild tableForClassExists not.
	testObject := SqSaveTestObjectChild new.
	testObject testSubString: 'Subtest'.
	testObject save.
	self assert: SqSaveTestObjectChild tableForClassExists! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tkow 9/2/2008 16:23'!
testTypeParameter
	| testObject1 testObject2 dbConnection result resultDict |
	testObject1 := SqSaveTestObject new.
	testObject1 testInteger: 42.
	testObject1 save.
	dbConnection := SqSConnectionManager getInstance getConnectionForCategory: 'TKSave'.
	result := dbConnection executeQuery: 'SELECT * FROM ' , SqSaveTestObject name asSqSaveTableName , ' WHERE test_integer = 42'.
	[ result next ] whileTrue: 
		[ resultDict := result currentRowAsDictionary.
		self assert: (resultDict at: dbConnection class inheritanceTypeField) = SqSaveTestObject name asString ].
	testObject2 := SqSaveTestObjectChild new.
	testObject2 testInteger: 21.
	testObject2 save! !

TestCase subclass: #SqSaveMagritteDescriptionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveMagritteDescriptionHandlerTest methodsFor: 'running' stamp: 'tk 6/26/2008 17:53'!
setUp
	SqSaveTestObject instVarNames do: 
		[ :ivn | 
		(SqSaveTestObject class includesSelector: ivn asDescriptionSelector) ifTrue: [ SqSaveTestObject class removeSelector: ivn asDescriptionSelector ].
		(SqSaveTestObject class includesSelector: ivn asSqSaveDescriptionSelector) ifTrue: 
			[ SqSaveTestObject class removeSelector: ivn asSqSaveDescriptionSelector ] ]! !

!SqSaveMagritteDescriptionHandlerTest methodsFor: 'tests' stamp: 'tk 8/31/2008 15:23'!
testCreateDescriptionMethods
	| obj |
	"self assert: (SqSaveTestObject respondsTo: #descriptionTestInteger) not.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestString) not.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestDate) not.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestSomething) not.
	obj := SqSaveTestObject new.
	obj testInteger: 42.
	obj testString: 'test'.
	obj testDate: Date today.
	(SqSaveSimpleDescriptionHandler for: obj) createDescriptionMethods.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestInteger).
	self assert: (SqSaveTestObject respondsTo: #descriptionTestString).
	self assert: (SqSaveTestObject respondsTo: #descriptionTestDate).
	self assert: (SqSaveTestObject respondsTo: #descriptionTestSomething) not"! !

TestCase subclass: #SqSaveStringExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 5/15/2008 15:46'!
testAsDescriptionSelector
	| testString |
	testString := 'instanceVariable'.
	self assert: (testString asDescriptionSelector = #descriptionInstanceVariable).
	testString := 'InstanceVariable'.
	self assert: (testString asDescriptionSelector = #descriptionInstanceVariable).
	testString := 'aInstanceVariable'.
	self assert: (testString asDescriptionSelector = #descriptionAInstanceVariable).
	! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 6/19/2008 15:34'!
testAsSqSaveDescriptionSelector
	| testString |
	testString := 'instanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #persistenceDescriptionInstanceVariable).
	testString := 'InstanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #persistenceDescriptionInstanceVariable).
	testString := 'aInstanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #persistenceDescriptionAInstanceVariable).
	! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 6/24/2008 15:33'!
testAsSqSaveTableName
	| testString |
	testString := 'TKSaveTestObject'.
	self assert: (testString asSqSaveTableName = 'tk_save_test_objects').
	testString := 'SqSaveTestObject'.
	self assert: (testString asSqSaveTableName = 'sq_save_test_objects').
	testString := 'SqSAVETestObject'.
	self assert: (testString asSqSaveTableName = 'sqsave_test_objects').
	testString := 'TKSAVETestObject'.
	self assert: (testString asSqSaveTableName = 'tksave_test_objects').
	! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 7/14/2008 17:45'!
testCollectionJoin
	self assert: ((#('hallo' 'welt') join: '-') = 'hallo-welt').
	self assert: ((#('hallo' 'welt') join: '') = 'hallowelt').
	self assert: ((#('hallo' 'welt') join: nil) = 'hallowelt')! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 7/7/2008 16:48'!
testDecamelized
	self assert: 'sq_save_type_field' decamelized = 'sq_save_type_field'.
	self assert: 'SqSaveTypeField' decamelized = 'sq_save_type_field'.! !

TestCase subclass: #SqSaveTableStructureHandlerTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

SqSaveTableStructureHandlerTest subclass: #SqSaveClassTableInheritanceStructureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveClassTableInheritanceStructureTest methodsFor: 'tests' stamp: 'tk 8/12/2008 17:56'!
testTableCreation
	| testObject |
	self clearDatabase.
	self setTestObjectInheritanceModeTo: #classTableInheritance.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 4.5243;
		testSubString: 'FortyTwo';
		testExtremelyDeepSubString: 'FortyTwoSquared'.
	testObject save.
	
	self assert: SqSaveTestObject tableForClassExists.
	self assert: SqSaveTestObjectChild tableForClassExists.
	self assert: SqSaveTestObjectEvenDeeperChild tableForClassExists.! !

SqSaveTableStructureHandlerTest subclass: #SqSaveSingleTableInheritanceStructureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveSingleTableInheritanceStructureTest methodsFor: 'tests' stamp: 'tk 7/14/2008 16:33'!
testTableCreation
	| testObject |
	self clearDatabase.
	self setTestObjectInheritanceModeTo: #singleTableInheritance.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 4.524;
		testSubString: 'FortyTwo';
		testExtremelyDeepSubString: 'FortyTwoSquared'.
	testObject save.
	self assert: SqSaveTestObject tableForClassExists.! !

!SqSaveTableStructureHandlerTest methodsFor: 'private' stamp: 'tk 7/21/2008 11:49'!
clearDatabase
	connection resetDatabase! !

!SqSaveTableStructureHandlerTest methodsFor: 'private' stamp: 'tk 7/8/2008 15:26'!
descriptorMethodCategory
	^'persistence-description'! !

!SqSaveTableStructureHandlerTest methodsFor: 'private' stamp: 'tk 7/8/2008 15:29'!
setTestObjectInheritanceModeTo: aSymbolString
	| code |
	code := 'persistenceInheritanceMode',String cr,String tab, '^#',aSymbolString.
	(SqSaveTestObject organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		SqSaveTestObject organization addCategory: (self descriptorMethodCategory).
	].
	SqSaveTestObject class compile: code classified: (self descriptorMethodCategory).! !

!SqSaveTableStructureHandlerTest methodsFor: 'running' stamp: 'tkow 9/2/2008 16:23'!
setUp
	connection := SqSConnectionManager getInstance getConnectionForCategory: 'TKSave'! !

!SqSaveTableStructureHandlerTest methodsFor: 'tests' stamp: 'tk 8/18/2008 10:34'!
testAlteredColumnDetection
	! !

!SqSaveTableStructureHandlerTest methodsFor: 'tests' stamp: 'tkow 9/2/2008 16:22'!
testCorrectClassChoosing
	| sampleObject |
	self setTestObjectInheritanceModeTo: #singleTableInheritance.
	sampleObject := SqSaveTestObject new.
	self assert: (SqSTableStructureHandler for: sampleObject) class = SqSSingleTableInheritanceTableStructureHandler.
	self setTestObjectInheritanceModeTo: #classTableInheritance.
	sampleObject := SqSaveTestObject new.
	self assert: (SqSTableStructureHandler for: sampleObject) class = SqSClassTableInheritanceTableStructureHandler! !

WAComponent subclass: #SqSaveTestComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Apps'!

!SqSaveTestComponent class methodsFor: 'as yet unclassified' stamp: 'tk 4/29/2008 15:44'!
canBeRoot
	^true! !

!SqSaveTestComponent methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 17:53'!
renderContentOn: html 
	html anchor
		callback: [ self call: SqSaveTestObject new asComponent addValidatedForm ];
		with: 'new'! !

!Object methodsFor: '*tksave' stamp: 'tk 8/26/2008 16:43'!
sqSaveClass
	^self class! !

Object subclass: #SqSBase
	instanceVariableNames: 'oid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 15:00'!
allClassTableColumns
	| |
	^(self descriptionHandler allTableColumnsForClass: self) ! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tk 9/2/2008 15:18'!
baseClass
	self superclass = SqSBase 
		ifTrue: [ ^ self ]
		ifFalse: [ ^ self superclass baseClass ]! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 17:06'!
columnNameForInstVar: ivarName
	^self descriptionHandler columnNameForInstVar: ivarName ofClass: self.! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/18/2008 17:44'!
createClassDescriptionFor: aSampleObject
	^(self descriptionHandler for: aSampleObject) createDescriptionMethods.! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tk 9/2/2008 15:21'!
descriptionHandler
	^ SqSSimpleDescriptionHandler! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/5/2008 13:49'!
doesNotUnderstand: aMessage
	| selector all attributes finderMethod startWord |
	selector := aMessage selector.
	finderMethod := selector prefixMatchesRegex: 'find[[:alpha:]]*By'.
	finderMethod ifTrue: [
		all := selector prefixMatchesRegex: 'findAllBy[[:upper:]]+'.
		all ifTrue:[startWord := 'findAllBy'] ifFalse: [startWord := 'findBy'].
		attributes := self findAttributesInSelector: aMessage selector beginWith: startWord.
		attributes ifNil: [
			^super doesNotUnderstand: aMessage.
		] ifNotNil: [
			^self performSearchFor: attributes withValues: (aMessage arguments) andReturnAll: all.
		].
	] ifFalse: [
		^super doesNotUnderstand: aMessage.
	].
	
	
	! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 18:15'!
findAttributesInSelector: aSelector beginWith: aString
	| elements searchedAttributes attrName |
	elements := aSelector subStrings: ':'.
	searchedAttributes := OrderedCollection new.
	elements at: 1 put: ((elements first) allButFirst: (aString size)).
	elements do:[ :el |
		attrName := el.
		(el beginsWith: 'and') ifTrue:[attrName := el allButFirst: 3].
		attrName at: 1 put: ((attrName first) asLowercase).
		(self allInstVarNames includes: attrName) ifTrue: [
			searchedAttributes add: attrName.	
		] ifFalse: [
			^nil
		]
	].
	^searchedAttributes! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:21'!
performSearchFor: instVars withValues: values andReturnAll: aBool 
	| limit results argumentDictionary |
	aBool ifFalse: [ limit := 1 ].
	argumentDictionary := (SqSTableStructureHandler for: self new) 
		buildSearchFor: instVars
		withValues: values.
	results := self sqSaveConnection 
		performSearchForObjectsOfClass: self
		withArguments: argumentDictionary
		andLimit: limit.
	aBool 
		ifTrue: [ ^ results ]
		ifFalse: 
			[ ^ results 
				at: 1
				ifAbsent: [ nil ] ]! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tk 9/2/2008 15:18'!
persistedInstVars
	| unpersistedVariables superClass |
	unpersistedVariables := Set withAll: self unpersistedInstVars.
	superClass := self superclass.
	[ superClass ~= SqSBase ] whileTrue: 
		[ unpersistedVariables addAll: superClass unpersistedInstVars.
		superClass := superClass superclass ].
	^ self allInstVarNames difference: unpersistedVariables! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/18/2008 16:20'!
persistenceInheritanceMode
	^#singleTableInheritance! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:23'!
sqSaveConnection
	^ SqSConnectionManager getInstance getConnectionForCategory: (self category subStrings: '-') first! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tk 8/29/2008 15:46'!
tableForClassExists
	^ self sqSaveConnection checkTableExistance: self tableName! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tk 9/2/2008 15:18'!
tableName
	(self descriptionHandler inheritanceModeForClass: self) = #singleTableInheritance 
		ifTrue: 
			[ self superclass = SqSBase 
				ifTrue: [ ^ self name asSqSaveTableName asEscapedSql ]
				ifFalse: [ ^ self superclass tableName ] ]
		ifFalse: [ ^ self name asSqSaveTableName asEscapedSql ]! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 14:08'!
unpersistedInstVars
	^#('oid')! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
updateTableColumns: changedColumnDictionary 
	| connection |
	connection := self sqSaveConnection.
	"first alter the altered columns"
	(changedColumnDictionary includesKey: #altered) ifTrue: 
		[ self sqSaveConnection alterTableColumns: (changedColumnDictionary at: #altered) ]! !

!SqSBase class methodsFor: 'as yet unclassified' stamp: 'tk 5/20/2008 14:14'!
useInstVarAccessors
	^false! !

!SqSBase methodsFor: 'nil' stamp: 'tk 7/15/2008 15:10'!
= anObject
	(anObject isKindOf: (self class)) ifFalse:[
		^false.
	].
	^anObject oid = self oid.! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 8/2/2008 11:58'!
allClassTableColumns
	| |
	^(self class allClassTableColumns) ! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 16:28'!
asSqlValueString
	^(self oid) asSqlValueString! !

!SqSBase methodsFor: 'nil' stamp: 'tk 8/12/2008 16:42'!
baseClass
	^self class baseClass! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 18:23'!
createRecord
	self tableStructureHandler insertObject.! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 17:17'!
descriptionHandler
	^self class descriptionHandler for: self! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:21'!
destroy
	self oid ifNotNil: [ (SqSTableStructureHandler for: self) deleteObject ]! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 7/31/2008 16:09'!
directlyReferencedObjects
	^self descriptionHandler directlyReferencedObjects! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 9/2/2008 15:18'!
escapedValueForInstanceVariable: iVar 
	| ivarValue |
	iVar = self class sqSaveConnection class inheritanceTypeField ifTrue: [ ^ self class name asSqlValueString ].
	ivarValue := self getValueOfInstVarNamed: iVar.
	(ivarValue class inheritsFrom: SqSBase) ifTrue: [ ivarValue isDirty ifTrue: [ ivarValue save ] ].
	(ivarValue respondsTo: #asSqlValueString) 
		ifTrue: [ ^ ivarValue asSqlValueString ]
		ifFalse: 
			[ self error: 'unstorable instance variable of type' , ivarValue class name , '!! Implement #asSqlValueString' ]! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 6/16/2008 11:52'!
getValueOfInstVarNamed: iVar
	| ivarValue |
	(self respondsTo: iVar asSymbol) ifTrue: [
		(self class useInstVarAccessors) ifTrue: [
			ivarValue := self perform: iVar asSymbol.	
		] ifFalse: [
			ivarValue := self instVarNamed: iVar asSymbol.
		]
	].
	^ivarValue! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 7/15/2008 15:13'!
hash
	^self oid ifNil: [0] ifNotNil: [self oid]! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 7/31/2008 16:34'!
indirectlyReferencedObjects
	^self descriptionHandler indirectlyReferencedObjects! !

!SqSBase methodsFor: 'accessing' stamp: 'tk 6/16/2008 13:35'!
isDirty
	"TODO: enhance me with some sort of check to determine whether an object needs restoring"
	^self newRecord! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 15:16'!
lazilyInitializedVariables
	^#()! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 8/12/2008 16:22'!
loadProxiedObjectOfVariable: ivarName
	^self tableStructureHandler loadProxiedObjectOfVariable: ivarName! !

!SqSBase methodsFor: 'accessing' stamp: 'tk 5/26/2008 15:18'!
newRecord
	^self oid isNil.! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 15:56'!
oid
	^oid! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 15:57'!
oid: anInteger
	oid := anInteger.! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 10:54'!
save
	" check if the table already exisits - this is for dev mode only - FACTOR OUT"
	| |
	self class createClassDescriptionFor: self.
	self class tableForClassExists ifTrue: [
		self tableStructureHandler updateTableStructure.
	] ifFalse: [ 
		self tableStructureHandler createTableStructure
	].

	"update the record if it is already present in the database, otherwhise create it"
	self newRecord 
		ifTrue: [ self createRecord ]
		ifFalse: [ self updateRecord ]! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 8/29/2008 16:15'!
setInstVarNamed: ivarName withValue: anObject
	| object lazy |
	"only set instvars of ourselves and ignore those of subclasses"
	(self class allInstVarNames includes: ivarName) ifTrue: [
		lazy := (self lazilyInitializedVariables includes: ivarName).
		object := (self descriptionHandler) 
						adaptObject: anObject toSpecificationOfInstVar: ivarName andDoItLaziliy: lazy.
		(self class useInstVarAccessors) ifTrue: [
			self perform: ((ivarName,':') asSymbol) with: object.
		] ifFalse: [
			self instVarNamed: ivarName put: object.
		]
	].! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
sqSaveConnection
	^ self class sqSaveConnection! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 5/21/2008 16:15'!
tableName
	^self class tableName! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:21'!
tableStructureHandler
	^ SqSTableStructureHandler for: self! !

!SqSBase methodsFor: 'as yet unclassified' stamp: 'tk 7/17/2008 15:46'!
updateRecord
	self tableStructureHandler updateObject
	! !

SqSBase subclass: #SqSaveTestObject
	instanceVariableNames: 'testInteger testString testDate testSomething'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveTestObject class methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 12:03'!
acceptsLoggingOfCompilation
	^false! !

!SqSaveTestObject class methodsFor: 'persistence-description' stamp: ''!
persistenceDescriptionTestDate
	^ SqSColumnDescription new manuallyMaintained: false;
		 columnName: 'test_date';
		 sqlType: 'DATE';
		 objectClass: #Date;
		 tableName: 'sq_save_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 yourself! !

!SqSaveTestObject class methodsFor: 'persistence-description' stamp: ''!
persistenceDescriptionTestInteger
	^ SqSColumnDescription new manuallyMaintained: false;
		 columnName: 'test_integer';
		 sqlType: 'SMALLINT';
		 objectClass: #SmallInteger;
		 tableName: 'sq_save_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 yourself! !

!SqSaveTestObject class methodsFor: 'persistence-description' stamp: ''!
persistenceDescriptionTestSomething
	^ SqSColumnDescription new manuallyMaintained: false;
		 columnName: 'test_something';
		 sqlType: 'FLOAT';
		 objectClass: #Float;
		 tableName: 'sq_save_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 yourself! !

!SqSaveTestObject class methodsFor: 'persistence-description' stamp: ''!
persistenceDescriptionTestString
	^ SqSColumnDescription new manuallyMaintained: false;
		 columnName: 'test_string';
		 sqlType: 'VARCHAR(254)';
		 objectClass: #ByteString;
		 tableName: 'sq_save_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 yourself! !

!SqSaveTestObject class methodsFor: 'persistence-description' stamp: ''!
persistenceInheritanceMode
	^ #singleTableInheritance! !

!SqSaveTestObject class methodsFor: 'as yet unclassified' stamp: ''!
wantsChangeSetLogging
	^ false! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testDate
	^ testDate! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testDate: anObject
	testDate := anObject! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger
	^ testInteger! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger: anObject
	testInteger := anObject! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething
	^ testSomething! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething: anObject
	testSomething := anObject! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString
	^ testString! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString: anObject
	testString := anObject! !

SqSaveTestObject subclass: #SqSaveTestObjectChild
	instanceVariableNames: 'testSubString testUnstoredVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveTestObjectChild class methodsFor: 'persistence-description' stamp: ''!
persistenceDescriptionTestSubString
	^ SqSColumnDescription new manuallyMaintained: false;
		 columnName: 'test_sub_string';
		 sqlType: 'VARCHAR(254)';
		 objectClass: #ByteString;
		 tableName: 'sq_save_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 yourself! !

!SqSaveTestObjectChild class methodsFor: 'magritte-description' stamp: 'tk 7/7/2008 16:30'!
unpersistedInstVars
	^#('testUnstoredVariable')! !

!SqSaveTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString
	^ testSubString! !

!SqSaveTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString: anObject
	testSubString := anObject! !

SqSaveTestObjectChild subclass: #SqSaveTestObjectEvenDeeperChild
	instanceVariableNames: 'testExtremelyDeepSubString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveTestObjectEvenDeeperChild class methodsFor: 'persistence-description' stamp: ''!
persistenceDescriptionTestExtremelyDeepSubString
	^ SqSColumnDescription new manuallyMaintained: false;
		 columnName: 'test_extremely_deep_sub_string';
		 sqlType: 'VARCHAR(254)';
		 objectClass: #ByteString;
		 tableName: 'sq_save_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 yourself! !

!SqSaveTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString
	^ testExtremelyDeepSubString! !

!SqSaveTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString: anObject
	testExtremelyDeepSubString := anObject! !

Object subclass: #SqSBaseWrapper
	instanceVariableNames: 'baseObject additionalInstVars instVarDescriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSBaseWrapper class methodsFor: 'as yet unclassified' stamp: 'tk 9/2/2008 15:18'!
for: anSqSaveBaseObject 
	"since objects of this class are ment to wrap SqSaveObjects, only those are allowed"
	(anSqSaveBaseObject class inheritsFrom: SqSBase) ifFalse: [ self error: 'Only SqSaveObjects allowed for this wrapper' ].
	^ self new
		baseObject: anSqSaveBaseObject;
		yourself! !

!SqSBaseWrapper methodsFor: 'as yet unclassified' stamp: 'tk 8/2/2008 16:13'!
addInstVarNamed: aString withValue: anObject
	self addInstVarNamed: aString withValue: anObject andDescription: nil.! !

!SqSBaseWrapper methodsFor: 'as yet unclassified' stamp: 'tk 8/2/2008 16:14'!
addInstVarNamed: aString withValue: anObject andDescription: anSqSaveColumnDescription
	self additionalInstVars at: aString put: anObject.
	self instVarDescriptions at: aString put: anSqSaveColumnDescription.! !

!SqSBaseWrapper methodsFor: 'accessing' stamp: 'tk 7/31/2008 17:43'!
additionalInstVars
	^ additionalInstVars! !

!SqSBaseWrapper methodsFor: 'accessing' stamp: 'tk 7/31/2008 17:43'!
additionalInstVars: anObject
	additionalInstVars := anObject! !

!SqSBaseWrapper methodsFor: 'as yet unclassified' stamp: 'tk 8/2/2008 16:22'!
allClassTableColumns
	| columns |
	columns := self baseObject allClassTableColumns.
	self instVarDescriptions associationsDo: [:assoc |
		assoc value ifNotNil: [
			columns at: assoc key ifAbsentPut: assoc value	
		]	
	].
	^columns! !

!SqSBaseWrapper methodsFor: 'accessing' stamp: 'tk 7/31/2008 17:43'!
baseObject
	^ baseObject! !

!SqSBaseWrapper methodsFor: 'accessing' stamp: 'tk 7/31/2008 17:43'!
baseObject: anObject
	baseObject := anObject! !

!SqSBaseWrapper methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:04'!
createRecord
	self baseObject oid: (self baseObject tableStructureHandler currentObject: self) insertObject! !

!SqSBaseWrapper methodsFor: 'as yet unclassified' stamp: 'tk 8/2/2008 11:12'!
doesNotUnderstand: aMessage
	| msgSelector setter |
	msgSelector := aMessage selector.
	setter := false.
	(msgSelector endsWith: ':') ifTrue: [
		msgSelector := msgSelector allButLast.
		setter := true
	].
	(self additionalInstVars includesKey: msgSelector) ifTrue: [
		setter ifTrue: [
			self additionalInstVars at: msgSelector put: aMessage arguments first.	
		] ifFalse: [
			^self additionalInstVars at: msgSelector
		]
	] ifFalse: [
		^aMessage sendTo: self baseObject
	].
	
	! !

!SqSBaseWrapper methodsFor: 'as yet unclassified' stamp: 'tk 8/2/2008 16:12'!
initialize
	super initialize.
	self additionalInstVars: Dictionary new.
	self instVarDescriptions: Dictionary new.! !

!SqSBaseWrapper methodsFor: 'accessing' stamp: 'tk 8/12/2008 17:38'!
instVarDescriptions
	^ instVarDescriptions! !

!SqSBaseWrapper methodsFor: 'accessing' stamp: 'tk 8/2/2008 16:11'!
instVarDescriptions: anObject
	instVarDescriptions := anObject! !

!SqSBaseWrapper methodsFor: 'as yet unclassified' stamp: 'tk 8/2/2008 16:52'!
save
	self baseObject newRecord ifTrue: [
		self createRecord.	
	] ifFalse: [
		self updateRecord.
	]! !

Object subclass: #SqSConnectionManager
	instanceVariableNames: 'connectionSpecificationDictionary connectionPool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Connection'!

SqSConnectionManager class
	instanceVariableNames: 'ConnectionManager'!

SqSConnectionManager class
	instanceVariableNames: 'ConnectionManager'!

!SqSConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 14:35'!
getInstance
	ConnectionManager ifNil: [
		ConnectionManager := self new.	
	].
	^ConnectionManager! !

!SqSConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 10:46'!
testCategory
	^'TKSave'! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool
	^ connectionPool! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool: anObject
	connectionPool := anObject! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionSpecificationDictionary
	^ connectionSpecificationDictionary! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionSpecificationDictionary: anObject
	connectionSpecificationDictionary := anObject! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tk 5/6/2008 10:31'!
getConnectionForCategory: aCategoryName
	| cSpec  |
	cSpec := self connectionSpecificationDictionary at: aCategoryName ifAbsent: nil.
	cSpec ifNotNil: [
		^self getConnectionFromQueue: aCategoryName for: cSpec.
	].
	self error: 'no connection data specified'.
	^nil
	! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tk 7/21/2008 14:16'!
getConnectionFromQueue: aCategoryName for: aConnectionSpecification
	| availableConnections |
	availableConnections := self connectionPool at: aCategoryName ifAbsent: nil.
	availableConnections ifNil: [
		self connectionPool at: aCategoryName put: {((Smalltalk at: aConnectionSpecification driverClass) 
				onHost: aConnectionSpecification hostname 
				port: aConnectionSpecification port  
				withUser: aConnectionSpecification username  
				password: aConnectionSpecification password  
				database: aConnectionSpecification database)}
	].
	^self pickConnectionFromQueue: availableConnections! !

!SqSConnectionManager methodsFor: 'initialization' stamp: 'tk 5/5/2008 14:37'!
initialize
	connectionSpecificationDictionary := Dictionary new.
	connectionPool := Dictionary new.! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tk 7/21/2008 14:16'!
pickConnectionFromQueue: aQueue	
	| con |
	con := aQueue first.
	con connectionIsAlive ifFalse: [
		con reconnect
	].
	^con! !

!SqSConnectionManager methodsFor: 'connection-access' stamp: 'tk 5/5/2008 14:42'!
setupConnectionSpecification: aConnectionSpecification for: aCategoryName
	self connectionSpecificationDictionary at: aCategoryName put: aConnectionSpecification! !

!SqSConnectionManager methodsFor: 'accessing' stamp: 'tkow 9/2/2008 16:24'!
setupTestConnection
	| conSpec |
	conSpec := SqSConnectionSpecification 
		user: 'thomas'
		password: 'test'
		port: 3306
		database: 'squeak_test'
		hostname: 'localhost'
		driver: #SqSMySQLDriver.
	self 
		setupConnectionSpecification: conSpec
		for: self class testCategory! !

Object subclass: #SqSConnectionSpecification
	instanceVariableNames: 'username password database port hostname driverClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Connection'!

!SqSConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:29'!
user: aUsername password: aPassword port: aPortNumber database: aDatabaseName driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: 'localhost'.! !

!SqSConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:29'!
user: aUsername password: aPassword port: aPortNumber database: aDatabaseName hostname: aHostname driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: aHostname.! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database
	^ database! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database: anObject
	database := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass
	^ driverClass! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass: anObject
	driverClass := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname
	^ hostname! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname: anObject
	hostname := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password
	^ password! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password: anObject
	password := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port
	^ port! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port: anObject
	port := anObject! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username
	^ username! !

!SqSConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username: anObject
	username := anObject! !

Object subclass: #SqSDescriptionHandler
	instanceVariableNames: 'alteredColumns currentObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSDescriptionHandler commentStamp: 'tk 5/22/2008 10:47' prior: 0!
A TKSaveDescriptionHandler is an abstract base class for the description handlers of the TKSave framework.
It defines methods that subclasses have to implement in order to be able to create, update, delete and read the descriptions of TKSaveBase subclasses.
It is therefore ment to provide a clean abstraction for the problem of describing the way objects are being stored within the database.

Instance Variables
	sampleObject:		anObject that determines how the descriptors will loke like
			
sampleObject
	- xxxxx!

!SqSDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:19'!
allTableColumnsForClass: aClass 
	| variables columnDict columnDescription |
	variables := self 
		perform: ((self inheritanceModeForClass: aClass) , 'TableColumnsForClass:') asSymbol
		with: aClass.
	columnDict := Dictionary new.
	variables do: 
		[ :var | 
		(aClass respondsTo: var asSqSaveDescriptionSelector) 
			ifTrue: 
				[ columnDescription := aClass perform: var asSqSaveDescriptionSelector.
				columnDescription describesCollection ifFalse: 
					[ columnDict 
						at: var
						put: columnDescription ] ]
			ifFalse: 
				[ columnDict 
					at: var
					put: (SqSColumnDescription new columnName: var decamelized) ] ].
	^ columnDict! !

!SqSDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:24'!
classTableInheritanceTableColumnsForClass: aClass 
	| instVars |
	instVars := Set newFrom: (aClass instVarNames difference: aClass unpersistedInstVars).
	aClass superclass = SqSBase ifTrue: [ instVars add: SqSDriver inheritanceTypeField ].
	^ instVars! !

!SqSDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 17:06'!
columnNameForInstVar: ivarName ofClass: aClass
	^ivarName decamelized! !

!SqSDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:04'!
for: aSampleObject 
	^ self new currentObject: aSampleObject! !

!SqSDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 6/18/2008 16:19'!
inheritanceModeForClass: aClass
	^aClass persistenceInheritanceMode! !

!SqSDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:24'!
singleTableInheritanceTableColumnsForClass: aClass 
	| classes sClass allInstVars |
	classes := Set newFrom: aClass allSubclasses.
	classes add: aClass.
	sClass := aClass superclass.
	[ sClass = SqSBase ] whileFalse: 
		[ classes add: sClass.
		sClass := sClass superclass ].
	allInstVars := Set new.
	classes do: 
		[ :klass | 
		allInstVars addAll: (klass instVarNames difference: klass unpersistedInstVars) ].
	classes ifNotEmpty: [ allInstVars add: SqSDriver inheritanceTypeField ].
	^ allInstVars! !

!SqSDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:11'!
useAdvancedCollections
	^true! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/11/2008 15:54'!
adaptObject: anObject toSpecificationOfInstVar: ivarName andDoItLaziliy: aBoolean
	^self subclassResponsibility! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/18/2008 17:51'!
alteredColumns
	^ alteredColumns! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/18/2008 17:51'!
alteredColumns: anObject
	alteredColumns := anObject! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tk 7/14/2008 17:14'!
columnDescriptionFor: ivarName
	self subclassResponsibility! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/15/2008 15:56'!
compileMethodCode: code intoClass: aClass
	| |
	(aClass organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		aClass organization addCategory: (self descriptorMethodCategory).
	].
	aClass class compile: code classified: (self descriptorMethodCategory).
	! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/18/2008 17:58'!
createColumnDescriptionForObject: anObject withLabel: aLabel linkedTo: aClass
	^''! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 6/18/2008 17:58'!
createDescriptionMethods
	"In order to not force everybody to implement the self describing functonality, just return an empty array with changed columns here"
	^Dictionary new! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 9/2/2008 16:19'!
createProxyFor: ivarName with: anObject 
	(anObject class = SqSProxy or: [ anObject class inheritsFrom: SqSProxy ]) 
		ifTrue: [ ^ anObject ]
		ifFalse: 
			[ ^ SqSProxy 
				for: anObject
				ofInstVar: ivarName
				in: self currentObject ]! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:06'!
currentObject
	^ currentObject! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:06'!
currentObject: anObject 
	currentObject := anObject! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 10:52'!
descriptorMethodCategory
	^'auto-generated-description'! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tk 9/2/2008 15:18'!
determineSqlTypeForObject: anObject 
	| connection sqlType classResolved currentClass |
	connection := self currentObject class sqSaveConnection.
	(anObject class inheritsFrom: SqSBase) 
		ifTrue: [ sqlType := connection integer ]
		ifFalse: 
			[ classResolved := false.
			currentClass := anObject class.
			[ classResolved or: [ currentClass = Object ] ] whileFalse: 
				[ (connection respondsTo: currentClass name withFirstCharacterDownshifted) 
					ifTrue: 
						[ sqlType := connection perform: currentClass name withFirstCharacterDownshifted.
						classResolved := true ]
					ifFalse: [ currentClass := currentClass superclass ] ] ].
	^ sqlType! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/31/2008 16:09'!
directlyReferencedObjects
	^self subclassResponsibility! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:05'!
getIvarValue: ivn 
	| anObject |
	anObject := nil.
	(self currentObject class allInstVarNames includes: ivn) ifTrue: 
		[ self currentObject class useInstVarAccessors 
			ifTrue: [ anObject := self currentObject perform: ivn asSymbol ]
			ifFalse: [ anObject := self currentObject instVarNamed: ivn asSymbol ] ].
	^ anObject! !

!SqSDescriptionHandler methodsFor: 'printing' stamp: 'tk 6/19/2008 14:17'!
indent: noOfTabs
	| indent |
	indent := String cr.
	0 to: noOfTabs do: [ :i |
		indent := indent, String tab.
	].
	^indent! !

!SqSDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/31/2008 16:35'!
indirectlyReferencedObjects
	^self subclassResponsibility! !

!SqSDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/18/2008 17:50'!
initialize
	super initialize.
	alteredColumns := Dictionary new.! !

SqSDescriptionHandler subclass: #SqSSimpleDescriptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSSimpleDescriptionHandler commentStamp: 'tk 6/19/2008 15:22' prior: 0!
A TKSaveMagritteDescriptionHandler is  .

Instance Variables
!

!SqSSimpleDescriptionHandler methodsFor: 'accessing' stamp: 'tk 9/1/2008 12:14'!
adaptObject: anObject toSpecificationOfInstVar: ivarName andDoItLaziliy: aBoolean 
	| persistenceDescr proxy |
	(self currentObject class respondsTo: ivarName asSqSaveDescriptionSelector asSymbol) ifTrue: [ 
		persistenceDescr := self currentObject class perform: ivarName asSqSaveDescriptionSelector.
		persistenceDescr associatedClass ifNil: [
			^anObject	
		] ifNotNil: [
			proxy := self createProxyFor: ivarName with: anObject.
			^proxy
		]
	] ifFalse: [ 
		^ nil 
	]! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:05'!
columnDescriptionFor: ivarName 
	^ self currentObject class perform: ivarName asSqSaveDescriptionSelector! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 9/2/2008 15:18'!
createCollectionDescriptionFor: ivn basedOn: aCollection inClass: aClass 
	| complexCollection isDict |
	aCollection ifNotEmpty: 
		[ complexCollection := true.
		isDict := aCollection isDictionary.
		aCollection do: 
			[ :el | 
			(complexCollection and: [ el isNil not ]) ifTrue: 
				[ complexCollection := (isDict 
					ifTrue: [ el value ]
					ifFalse: [ el ]) class inheritsFrom: SqSBase ] ].
		complexCollection 
			ifTrue: 
				[ "create a collection description, upon which a join table will be created later on"
				^ self 
					persistenceDescriptionForCollection: aCollection
					withLabel: ivn
				"if not store them as a serialized BLOB" ]
			ifFalse: 
				[ ^ self 
					persistenceDescriptionForObject: aCollection
					withLabel: ivn
					storedInTableNamed: aClass tableName ] ].
	^ nil! !

!SqSSimpleDescriptionHandler methodsFor: 'accessing' stamp: 'tkow 9/2/2008 16:19'!
createColumnDescriptionForObject: anObject withLabel: aLabel linkedTo: aClass storedInTableNamed: tableName 
	| column sqlType |
	column := SqSColumnDescription new.
	sqlType := self determineSqlTypeForObject: anObject.
	column
		columnName: aLabel decamelized;
		objectClass: anObject class name asSymbol;
		tableName: tableName;
		sqlType: sqlType.
	aClass ifNotNil: [ column associatedClass: aClass ].
	^ column! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/31/2008 15:15'!
createDescriptionMethods
	| anObject targetClass |
	self currentObject class persistedInstVars do: 
		[ :ivn | 
		anObject := self getIvarValue: ivn.
		targetClass := self findTargetClassForDescriptorOfIvarNamed: ivn.
		anObject ifNotNil: 
			[ (targetClass respondsTo: ivn asSqSaveDescriptionSelector) 
				ifTrue: 
					[ self 
						updatePersistenceDescriptorFor: ivn
						basedOn: anObject
						inClass: targetClass ]
				ifFalse: 
					[self 
						writePersistenceDescriptorFor: ivn
						basedOn: anObject
						inClass: targetClass ] ] ].
	^ self alteredColumns! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/15/2008 16:47'!
createPersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass
	| |
	^(anObject isCollection) ifTrue: [
		self createCollectionDescriptionFor: ivn basedOn: anObject inClass: aClass
	] ifFalse: [
		self persistenceDescriptionForObject: anObject withLabel: ivn storedInTableNamed: aClass tableName
	].! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/31/2008 15:17'!
descriptorMethodCategory
	^'persistence-description'! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:05'!
directlyReferencedObjects
	| referencedObjects descr ivarValue |
	referencedObjects := OrderedCollection new.
	self currentObject class persistedInstVars do: 
		[ :ivn | 
		(self currentObject class respondsTo: ivn asSqSaveDescriptionSelector) ifTrue: 
			[ descr := self currentObject class perform: ivn asSqSaveDescriptionSelector.
			descr associatedClass ifNotNil: 
				[ ivarValue := self getIvarValue: ivn.
				ivarValue ifNotNil: [ referencedObjects add: ivarValue ] ] ] ].
	^ referencedObjects! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 9/2/2008 15:18'!
findTargetClassForDescriptorOfIvarNamed: ivn 
	| targetClass |
	targetClass := self currentObject class.
	[ targetClass ~= SqSBase ] whileTrue: 
		[ (targetClass instVarNames includes: ivn) ifTrue: [ ^ targetClass ].
		targetClass := targetClass superclass ].
	self error: 'instance variable named ' , ivn , ' could not be found in the class hierarchy of ' , self currentObject class name! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:05'!
indirectlyReferencedObjects
	| referencedObjects descr ivarValue |
	referencedObjects := OrderedCollection new.
	self currentObject class persistedInstVars do: 
		[ :ivn | 
		(self currentObject class respondsTo: ivn asSqSaveDescriptionSelector) ifTrue: 
			[ descr := self currentObject class perform: ivn asSqSaveDescriptionSelector.
			descr describesCollection ifTrue: 
				[ ivarValue := self getIvarValue: ivn.
				ivarValue ifNotNil: 
					[ referencedObjects add: (Dictionary newFrom: { 
								(#collection -> ivarValue).
								(#description -> descr).
								(#variable -> ivn)
							 }) ] ] ] ].
	^ referencedObjects! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:19'!
persistenceDescriptionForCollection: aCollection withLabel: ivn 
	| ownerColumn collectionSample referenceColumn |
	ownerColumn := SqSColumnDescription new
		sqlType: self currentObject sqSaveConnection integer;
		columnName: self currentObject baseClass name decamelized , '_id';
		foreignKey: (SqSForeignKeyDescription new
				referencedColumns: (OrderedCollection with: self currentObject sqSaveConnection class objectIdField);
				referencedTable: self currentObject tableName;
				deleteActions: #(#CASCADE ));
		canBeNull: false.
	collectionSample := aCollection first.
	referenceColumn := SqSColumnDescription new
		sqlType: collectionSample sqSaveConnection integer;
		columnName: ivn decamelized , '_id';
		canBeNull: false.
	self class useAdvancedCollections ifFalse: 
		[ referenceColumn foreignKey: (SqSForeignKeyDescription new
				referencedColumns: (OrderedCollection with: collectionSample sqSaveConnection class objectIdField);
				referencedTable: collectionSample baseClass tableName;
				deleteActions: #(#CASCADE )) ].
	^ SqSCollectionDescription new
		referenceTableName: collectionSample baseClass tableName;
		referenceColumn: referenceColumn;
		collectionClass: aCollection sqSaveClass;
		maintainOrder: self class useAdvancedCollections;
		ownerColumn: ownerColumn;
		includedClass: collectionSample baseClass;
		joinTableName: self currentObject baseClass name asSqSaveTableName , '_' , ivn decamelized! !

!SqSSimpleDescriptionHandler methodsFor: 'accessing' stamp: 'tk 9/2/2008 15:18'!
persistenceDescriptionForObject: anObject withLabel: aLabel storedInTableNamed: tableName 
	| linkedClass |
	linkedClass := (anObject class inheritsFrom: SqSBase) 
		ifTrue: [ anObject class name asSymbol ]
		ifFalse: [ nil ].
	^ self 
		createColumnDescriptionForObject: anObject
		withLabel: aLabel
		linkedTo: linkedClass
		storedInTableNamed: tableName! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 16:46'!
updatePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass
	| previousClass oldDescription |
	oldDescription := aClass perform: ivn asSqSaveDescriptionSelector.
	"for the brave ones, we leave everything as is"
	oldDescription manuallyMaintained ifFalse: [
		oldDescription describesCollection ifFalse: [
			previousClass := Smalltalk at: oldDescription objectClass asSymbol.
			"if we have a subclass of our previous class, we're fine - otherwhise, we have to alter the table and the description"
			((anObject class inheritsFrom: previousClass) or: [anObject sqSaveClass = previousClass]) ifFalse: [
				self writePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass.
				"TODO: this is the place where we should ask the user if the change is ok???"
			]
		] ifTrue: [
			self writePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass.
		]
	].	
	! !

!SqSSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/15/2008 16:42'!
writePersistenceDescriptorFor: ivn basedOn: anObject inClass: targetClass
	| description code |
	description := self createPersistenceDescriptorFor: ivn basedOn: anObject  inClass: targetClass.
	description ifNotNil: [
		code := ivn asSqSaveDescriptionSelector, String cr.
		code := code,'^', description creationCode.
		self compileMethodCode: code intoClass: targetClass
	].! !

Object subclass: #SqSDriver
	instanceVariableNames: ''
	classVariableNames: 'TableCache'
	poolDictionaries: ''
	category: 'TKSave-Connection'!

!SqSDriver class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:31'!
collectionOrderField
	^'order_number'! !

!SqSDriver class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:30'!
inheritanceTypeField
	^ 'sq_save_type_field'! !

!SqSDriver class methodsFor: 'as yet unclassified' stamp: 'tk 9/1/2008 12:06'!
nilValue
	^0! !

!SqSDriver class methodsFor: 'as yet unclassified' stamp: 'tk 8/5/2008 17:24'!
objectIdField
	^'oid'! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:42'!
addColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToAddColumn: column).	
		]
	"]"
	! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/29/2008 15:59'!
addEntries: addedIds inJoinTable: aDescription forOwnerId: oid
	addedIds do: [:ids |
		| sql |
		sql	:= self queryToAddEntry: ids toJoinTable: aDescription forOwnerId: oid.
		self executeQuery: sql.
	]	! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:47'!
alterColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToAlterColumn: column).	
		]
	"]"
	! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 7/7/2008 17:00'!
bodyForInsertOf: anObject
	| fields values |
	fields := ''.
	values := ''.
	anObject class allClassTableColumns associationsDo:[ :assoc |
		fields := fields, assoc value columnName, ', '.
		values := values, (anObject escapedValueForInstanceVariable: assoc key), ', '.
	].
	fields := fields allButLast:2.
	values := values allButLast:2.
	^'(',fields,') VALUES (',values,')'! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:32'!
boolean
	^'BOOLEAN'.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/29/2008 15:46'!
checkTableExistance: aClassName 
	| result tableExists |
	result := self executeQuery: 'SHOW TABLES'.
	tableExists := false.
	[ result next ] whileTrue: 
		[ tableExists ifFalse: 
			[ tableExists := (result valueNamed: result columns first name) = aClassName ] ].
	^ tableExists! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:19'!
commitTransaction	
	self executeQuery:(self queryForCommit). .! !

!SqSDriver methodsFor: 'accessing' stamp: 'wh 8/17/2006 15:37'!
connection
	self subclassResponsibility.! !

!SqSDriver methodsFor: 'accessing' stamp: 'tk 5/13/2008 15:17'!
connectionIsAlive
	self subclassResponsibility.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/26/2008 17:33'!
createJoinTableNamed: tableName withColumns: columns
	self executeQuery: (self queryToCreateJoinTableNamed: tableName withColumns: columns andOrderField: true). ! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/26/2008 17:33'!
createJoinTableNamed: tableName withColumns: columns andOrderField: bool
	self executeQuery: (self queryToCreateJoinTableNamed: tableName withColumns: columns andOrderField: bool). ! !

!SqSDriver methodsFor: 'accessing' stamp: 'tkow 9/2/2008 16:20'!
createObjectsOfClass: aClass fromResultSet: result 
	| resultDicts targetClass object ivarValue results |
	results := OrderedCollection new.
	resultDicts := self rowDictionariesForResultSet: result.
	resultDicts do: 
		[ :resultDict | 
		targetClass := resultDicts first 
			at: self class inheritanceTypeField
			ifAbsent: [ aClass name ].
		targetClass := Smalltalk 
			at: targetClass asSymbol
			ifAbsent: [ nil ].
		targetClass ifNotNil: 
			[ object := targetClass new.
			object oid: (resultDict at: self class objectIdField).
			targetClass persistedInstVars do: 
				[ :ivar | 
				"set up a proxy object, if the value is not available within the current table"
				ivarValue := resultDict 
					at: (targetClass columnNameForInstVar: ivar)
					ifAbsent: 
						[ SqSCollectionProxy 
							for: nil
							ofInstVar: ivar
							in: object ].
				object 
					setInstVarNamed: ivar
					withValue: ivarValue ].
			results add: object ] ].
	^ results! !

!SqSDriver methodsFor: 'accessing' stamp: 'tk 4/29/2008 17:20'!
database
	self subclassResponsibility.
	! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
date
	^'DATE'.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
dateAndTime
	^'DATETIME'.
	! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
decimalIntegerSize: m scale: d
	^'DECIMAL('m asString,',',d asString,')'.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
double
	^'DOUBLE'.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 22:02'!
escapedRowName: aString
	^'`',aString,'`'.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
float
	^'FLOAT'.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/29/2008 16:43'!
getCollectionDescribedBy: descr forObjectId: oid
	| sql results |
	sql := 'SELECT ', descr referenceTableName, '.* '.
	sql := sql, 'FROM ', descr joinTableName, ', ', descr referenceTableName, ' '.
	sql := sql, 'WHERE ', descr joinTableName ,'.', descr ownerColumn columnName, ' = ', oid asString.
	sql := sql, ' AND ', descr joinTableName,'.', descr referenceColumn columnName.
	sql := sql, ' = ', descr referenceTableName, '.', self class objectIdField.
	descr maintainOrder ifTrue: [
		sql := sql, ' ORDER BY ', self class collectionOrderField
	].
	results := self executeQuery: sql.
	^self createObjectsOfClass: descr includedClass fromResultSet: results. ! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:15'!
inTransactionDo: aBlock
	self inTransactionDo: aBlock onError: [self rollback].! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/30/2008 14:36'!
inTransactionDo: aBlock onError: anErrorBlock
	self startTransaction.
	[aBlock value] ifError: [:err |
		"anErrorBlock value."
		self error: err.
	].
	self commitTransaction.
	! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
integer
	^'INTEGER'.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
largeInteger
	^'BIGINT'.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 5/22/2008 17:04'!
lastOidFromTable: aTable
	self subclassResponsibility! !

!SqSDriver methodsFor: 'accessing' stamp: 'tk 7/29/2008 11:57'!
log: aString
	"TODO: viable solution for logging - Transcript is just weigh to slow"
	Transcript show: '+++++++++++++++++++';
		show: String cr;
		show: aString;
		show: String cr.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
mediumInteger
	^'MEDIUMINT'.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/29/2008 15:47'!
moveEntries: movedIds inJoinTable: aDescription forOwnerId: oid
	| sql |
	movedIds do: [:ids |
		sql := self queryToUpdateEntries: ids inJoinTable: aDescription forOwnerId: oid.
		self executeQuery: (sql).
	]
	! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 23:34'!
oid
	^self unsignedInteger, ' PRIMARY KEY '.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/13/2006 12:30'!
oidColumn
	"I believe this is the SQL standard but I don't think any SQL databases 
		follow it "

	^'INTEGER PRIMARY KEY GENERATED ALWAYS AS IDENTITY'! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 19:51'!
performSearchForObjectsOfClass: aClass withArguments: argumentDictionary andLimit: aLimit
	| sql result results |
	sql := 'SELECT * FROM ', (argumentDictionary keys join: ' NATURAL JOIN '), ' WHERE '.
	argumentDictionary associationsDo: [:assoc |
		assoc value associationsDo: [ :joiner |
			sql := sql, '('.
			sql := sql, ((joiner value collect: [:searchAttr |
				assoc key,'.', searchAttr key, ' = ', searchAttr value asSqlValueString
			]) join: (' ',joiner key,' ')).
			sql := sql,') AND '.
		].
	].
	sql := sql allButLast: 5.
	aLimit ifNotNil: [sql := sql, ' LIMIT ', aLimit asString].
	result := self executeQuery: (sql).
	results := self createObjectsOfClass: aClass fromResultSet: result.
	^results! !

!SqSDriver methodsFor: 'sql statements' stamp: 'wh 8/10/2006 17:05'!
queryForCommit
	^'COMMIT'.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 7/10/2008 17:15'!
queryForForeignKeyConstraint: aForeignKeyDescription ofColumn: aColumnName
	| sql |
	sql := 'FOREIGN KEY (',aColumnName,') REFERENCES '.
	sql := sql, aForeignKeyDescription referencedTable,'(', aForeignKeyDescription referencedColumns first,') '.
	aForeignKeyDescription deleteActions ifNotEmpty: [sql := sql, 'ON DELETE'].
	aForeignKeyDescription deleteActions do: [:action | sql := sql, ' ',action].
	aForeignKeyDescription updateActions ifNotEmpty: [sql := sql, 'ON UPDATE'].
	aForeignKeyDescription updateActions do: [:action | sql := sql, ' ',action].
	^sql! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/26/2008 17:30'!
queryForObjectsOf: aClass byAttributes: argumentDictionary inTable: aTableName withLimit: limit 
	| query result results |
	query := 'SELECT * FROM ' , aTableName , ' WHERE '.
	(aClass descriptionHandler inheritanceModeForClass: aClass) = #singleTableInheritance ifTrue: 
		[ query := query , '( ' , self class inheritanceTypeField , ' = ' , aClass name asSqlValueString.
		aClass allSubclasses do: 
			[ :subClass | 
			query := query , ' OR ' , self class inheritanceTypeField , ' = ' , subClass name asSqlValueString ].
		query := query , ') AND ' ].
	argumentDictionary associationsDo: 
		[ :pair | 
		query := query , pair key , ' = ' , pair value asSqlValueString , ' AND ' ].
	query := query allButLast: 5.
	limit ifNotNil: [ query := query , ' LIMIT ' , limit asString ].
	result := self executeQuery: query.
	results := self 
		createObjectsOfClass: aClass
		fromResultSet: result.
	^ results! !

!SqSDriver methodsFor: 'sql statements' stamp: 'wh 8/11/2006 09:23'!
queryForRollback
	^'ROLLBACK'.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'wh 8/13/2006 12:41'!
queryForStartTransaction
	^'START TRANSACTION'.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/25/2008 11:45'!
queryToAddColumn: aColumn
	| sql |
	sql := 'ALTER TABLE ', aColumn tableName, ' ADD COLUMN '.
	sql := sql, aColumn columnName, ' ', aColumn sqlType.
	aColumn canBeNull ifFalse: [
		sql := sql, ' NOT NULL'	
	].
	^sql! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 9/2/2008 11:35'!
queryToAddEntry: ids toJoinTable: aDescription forOwnerId: oid
	| sql |
	sql := 'INSERT INTO ', aDescription joinTableName, '('.
	sql := sql, aDescription ownerColumn columnName, ', ', aDescription referenceColumn columnName. 
	aDescription maintainOrder ifTrue: [
		sql := sql, ', ', self	class collectionOrderField
	].
	sql := sql, ') VALUES (', oid asString, ',', (ids join: ','), ')'.
	^sql
	! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/25/2008 11:48'!
queryToAlterColumn: aColumn
	| sql |
	sql := 'ALTER TABLE ', aColumn tableName, ' MODIFY '.
	sql := sql, aColumn columnName, ' ', aColumn sqlType.
	aColumn canBeNull ifFalse: [
		sql := sql, ' NOT NULL'	
	].
	^sql! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 6/19/2008 16:56'!
queryToAlterColumns: anAssociation forTable: tableName
	| sql |
	sql := 'ALTER TABLE ',tableName, ' MODIFY '.
	sql	:= sql, (self escapedRowName: anAssociation key), ' ', anAssociation value.
	^sql.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/26/2008 17:43'!
queryToCreateJoinTableNamed: tableName withColumns: columns andOrderField: aBool
	| sql |
	sql := 'CREATE TABLE ', tableName, ' ('.
	"create the three (or two...) columns of the join table"
	columns do: [ :columnDescr |
		sql := sql, columnDescr columnName, ' ', columnDescr sqlType.
		columnDescr foreignKey ifNotNil: [
			sql := sql, ' NOT NULL, ', (self queryForForeignKeyConstraint: columnDescr foreignKey ofColumn: columnDescr columnName). 	
		].
		sql := sql, ', '.
	].
	aBool ifTrue: [
		sql := sql, self class collectionOrderField,' ',(self integer),' NOT NULL, '.
	].
	
	"and set up a primary key over those columns (will be always unique)"
	sql := sql, ' PRIMARY KEY (', ((columns collect: [:columnDescr | columnDescr columnName]) join: ', ').
	aBool ifTrue: [
		sql := sql, ', ',self class collectionOrderField.
	].
	sql := sql, '))'.
	^sql! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 5/22/2008 15:31'!
queryToCreateObject: anObject
	|sql|
	sql := 'INSERT INTO ', anObject tableName, ' '.
	sql := sql,(self bodyForInsertOf: anObject). 
	^sql.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/26/2008 17:30'!
queryToCreateTableNamed: tableName withColumns: columnDict 
	| sql type primaryKeyColumns |
	sql := 'CREATE TABLE ' , tableName , ' ('.
	(columnDict includesKey: 'oid') ifFalse: [ sql := sql , '`oid` ' , self oidColumn , ',' ].
	columnDict associationsDo: 
		[ :assoc | 
		type := self smallInteger.
		assoc value sqlType 
			ifNil: 
				[ assoc key = self class inheritanceTypeField ifTrue: [ type := self string ] ]
			ifNotNil: [ type := assoc value sqlType ].
		sql := sql , (self escapedRowName: assoc value columnName) , ' ' , type.
		assoc value canBeNull ifFalse: [ sql := sql , ' NOT NULL' ].
		sql := sql , ', '.
		assoc value foreignKey ifNotNil: 
			[ sql := sql , (self 
					queryForForeignKeyConstraint: assoc value foreignKey
					ofColumn: assoc key) , ', ' ] ].
	sql := sql allButLast: 2.
	primaryKeyColumns := (columnDict values select: [ :columnDescr | columnDescr isPrimaryKey ]) collect: [ :columnDescr | columnDescr columnName ].
	primaryKeyColumns ifNotEmpty: 
		[ sql := sql , ', PRIMARY KEY (' , (primaryKeyColumns join: ', ') , ')' ].
	sql := sql , ')'.
	^ sql! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/25/2008 11:46'!
queryToRemoveColumn: aColumn
	^'ALTER TABLE ',aColumn tableName,' DROP COLUMN ', aColumn columnName.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/29/2008 15:31'!
queryToRemoveIds: ids ofColumn: columnName fromTable: aDescription forOwnerId: oid
	| sql |
	sql := 'DELETE FROM ', aDescription joinTableName, ' WHERE '.
	sql := sql, columnName, ' IN (', (ids join: ','), ') AND '.
	sql := sql, aDescription ownerColumn columnName, ' = ', oid asString.
	^sql! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 4/29/2008 16:11'!
queryToRemoveTableForClass: aClass
	| sql |
	sql := 'DROP TABLE ', aClass name.
	^sql.! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/25/2008 11:41'!
queryToRenameColumns: columnsCollection
	| oldColumn sql newColumn |
	oldColumn := columnsCollection first.
	newColumn := columnsCollection at: 2.
	sql := 'ALTER TABLE ', oldColumn tableName, ' CHANGE '.
	sql := sql, oldColumn columnName, ' ', newColumn columnName, ' ', newColumn sqlType.
	^sql 
	! !

!SqSDriver methodsFor: 'sql statements' stamp: 'tk 8/29/2008 15:54'!
queryToUpdateEntries: movedIds inJoinTable: aDescription forOwnerId: oid
	"orderNumber := movedIds last.
	newObjectId := movedIds first."
	| sql |
	sql := 'UPDATE ', aDescription joinTableName, '	SET '.
	sql := sql, aDescription referenceColumn columnName, ' = ', movedIds first asString.
	sql := sql, ' WHERE ', aDescription ownerColumn columnName, ' = ', oid asString.
	sql := sql, ' AND ', self class collectionOrderField, ' = ', movedIds last asString.
	^sql
	
	
	! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 15:20'!
reServeObject
	^self unsignedInteger.! !

!SqSDriver methodsFor: 'accessing' stamp: 'tk 7/21/2008 14:18'!
reconnect
	self subclassResponsibility.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:45'!
removeColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToRemoveColumn: column).	
		]
	"]"
	! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/29/2008 15:29'!
removeEntries: deletedIds fromJoinTable: aDescription forOwnerId: oid
	| sql ids columnName |
	aDescription maintainOrder ifTrue: [
		ids := deletedIds collect: [: dids | dids last].
		columnName := self class collectionOrderField.
	] ifFalse: [
		ids := deletedIds collect: [: dids | dids first].
		columnName := aDescription referenceColumn columnName
	].
	sql := self queryToRemoveIds: ids ofColumn: columnName fromTable: aDescription forOwnerId: oid.
	self executeQuery: sql.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/15/2008 16:06'!
removeObjectWithId: oid fromTable: tableName
	| sql |
	sql := 'DELETE FROM ',tableName,' WHERE oid = ',oid asString.
	self executeQuery: (sql).! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:41'!
renameColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:columnPair |
			self executeQuery: (self queryToRenameColumns: columnPair).	
		]
	"]"
	! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/30/2008 15:09'!
resetDatabase
	| |
	self executeQuery: 'DROP DATABASE ', self database.
	self executeQuery: 'CREATE DATABASE ', self database.
	self reconnect.
	! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/18/2008 16:22'!
rollback
	"self localCache do:[:object | object rollback ].
	self rollbackDbTransaction."
	"self executeQuery: 'ROLLBACK'"! !

!SqSDriver methodsFor: 'database operations' stamp: 'wh 8/11/2006 09:24'!
rollbackDbTransaction
	self executeQuery:(self queryForRollback) .! !

!SqSDriver methodsFor: 'accessing' stamp: 'tk 8/31/2008 15:05'!
rowDictionariesForResultSet: result
	^self subclassResponsibility! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/13/2006 12:16'!
serial
	self subclassResponsibility.
	! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
smallInteger
	^'SMALLINT'! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:18'!
startTransaction
	self executeQuery:(self queryForStartTransaction).! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 15:42'!
storeColumns: columnDict inTable: aTableName
	self storeColumns: columnDict inTable: aTableName  andReturnOId: false.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:07'!
storeColumns: columnDict inTable: aTableName andReturnOId: aBool
	"columnDict is a Dictionary where a SqSaveColumnDescription points to the stored value"
	| sql keys values |
	sql := 'INSERT INTO ', aTableName,' ('.
	keys := ''.
	values := ''.
	columnDict associationsDo: [:assoc |
		keys := keys, assoc key, ', '.
		values := values, assoc value asString, ', '.	
	].
	sql := sql, (keys allButLast: 2), ') VALUES (', (values allButLast: 2), ')'.
	self executeQuery: (sql).
	aBool ifTrue: [
		^self lastOidFromTable: aTableName	
	].! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
string
	^self stringWithLength: 254.
	! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 23:21'!
stringWithLength: m
	^'VARCHAR(',m asString,')'.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
text
	^'TEXT'.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
time
	^'TIME'.! !

!SqSDriver methodsFor: 'column types' stamp: 'wh 8/16/2006 22:18'!
unsignedInteger
	"The SQL standard does not support unsigned Integer 
		imagine my suprise "
	^'INTEGER '.! !

!SqSDriver methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:14'!
updateFields: columnDict ofObjectWithId: oid inTable: aTableName 
	| sql |
	sql := 'UPDATE ' , aTableName , ' SET '.
	columnDict associationsDo: [ :assoc | sql := sql , assoc key , ' = ' , assoc value asString , ', ' ].
	sql := (sql allButLast: 2) , ' WHERE oid = ' , oid asString.
	self executeQuery: sql! !

SqSDriver subclass: #SqSMySQLDriver
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Connection'!

!SqSMySQLDriver class methodsFor: 'as yet unclassified' stamp: 'wh 8/8/2006 23:11'!
onHost: aHost port: aPort withUser: aUser password: aPassword database: aDatabase
	^(self new ) 
		onHost: aHost 
		port: aPort 
		withUser: aUser 
		password: aPassword 
		database: aDatabase.! !

!SqSMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/8/2006 10:18'!
connection
	^connection! !

!SqSMySQLDriver methodsFor: 'accessing' stamp: 'tk 7/18/2008 15:53'!
connectionIsAlive
	^self connection socket isConnected! !

!SqSMySQLDriver methodsFor: 'accessing' stamp: 'tk 4/29/2008 17:22'!
database
	^connection connectionSpec database! !

!SqSMySQLDriver methodsFor: 'accessing' stamp: 'tk 9/2/2008 14:29'!
driverClass
	^JdmConnection! !

!SqSMySQLDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 22:02'!
escapedRowName: aString
	^'`',aString,'`'.! !

!SqSMySQLDriver methodsFor: 'database operations' stamp: 'tk 7/21/2008 14:54'!
executeQuery: aQuery
	| |
	self log: aQuery.
	^(self connection createStatement) executeQuery:(aQuery)! !

!SqSMySQLDriver methodsFor: 'database operations' stamp: 'tk 7/21/2008 14:55'!
lastOidFromTable: aTable
	 | oid |
	"MySQL will only retrun the last ID. Postgres needs the table part"  
	(self executeQuery: 'SELECT LAST_INSERT_ID() AS OID')
		collect: [:table |
			oid := (table at: 'OID') asString asInteger. 	
		].
	^oid.
	! !

!SqSMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/8/2006 10:20'!
newConnection
	^ self driverClass on: (self connection connectionSpec).! !

!SqSMySQLDriver methodsFor: 'column types' stamp: 'wh 8/13/2006 12:21'!
oidColumn
	^'INT(11) NOT NULL PRIMARY KEY AUTO_INCREMENT '.! !

!SqSMySQLDriver methodsFor: 'database operations' stamp: 'wh 9/12/2006 16:27'!
oidForNewObject: anObject
	 | oid |
	(self connection createStatement) executeQuery: (self queryForNewObjectOfClass:(anObject class)).
	"Ugh MySQL driver trickery"
	(self executeQuery: 'SELECT LAST_INSERT_ID() AS OID')
		collect: [:table |
			oid := (table at: 'OID') asString asInteger. 	
		].
	^oid.
	! !

!SqSMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/16/2006 23:39'!
onHost: aHost port: aPort withUser: aUser password: aPassword database: aDatabase
	| spec |
	Socket initializeNetwork.
	spec :=    (JdmConnectionSpec new initialize
        user: aUser; password: aPassword;
        host: (NetNameResolver addressForName: aHost);
        database: aDatabase;
        port: aPort).
	connection := (self driverClass) on: spec.
	! !

!SqSMySQLDriver methodsFor: 'sql statements' stamp: 'tk 8/26/2008 17:35'!
queryToCreateJoinTableNamed: tableName withColumns: columns andOrderField: aBool
	^ (super queryToCreateJoinTableNamed: tableName withColumns: columns andOrderField: aBool) , ' ENGINE=INNODB'.! !

!SqSMySQLDriver methodsFor: 'sql statements' stamp: 'tk 7/10/2008 16:54'!
queryToCreateTableNamed: tableName withColumns: columnDict
	^ (super queryToCreateTableNamed: tableName withColumns: columnDict) , ' ENGINE=INNODB'.! !

!SqSMySQLDriver methodsFor: 'accessing' stamp: 'tk 7/29/2008 11:56'!
reconnect
	self log: 'reconnecting'.
	[connection close] ifError: [:err | Transcript show: err].
	connection initialize2.! !

!SqSMySQLDriver methodsFor: 'converting' stamp: 'tk 8/31/2008 15:06'!
rowDictionariesForResultSet: result 
	| resultDicts |
	resultDicts := OrderedCollection new.
	"store all data rows in our own structure - this way we can issue new commands upon object creation"
	[ result next ] whileTrue: [ resultDicts add: result currentRowAsDictionary copy ].
	^resultDicts! !

Object subclass: #SqSForeignKeyDescription
	instanceVariableNames: 'referencedColumns referencedTable updateActions deleteActions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
deleteActions
	^ deleteActions! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
deleteActions: anObject
	deleteActions := anObject! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:31'!
initialize
	super initialize.
	self updateActions: #().
	self deleteActions: #().! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedColumns
	^ referencedColumns! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedColumns: anObject
	referencedColumns := anObject! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedTable
	^ referencedTable! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedTable: anObject
	referencedTable := anObject! !

!SqSForeignKeyDescription methodsFor: 'as yet unclassified' stamp: 'tk 7/22/2008 13:54'!
storeOn: aStream

	aStream nextPut: $(.
	aStream nextPutAll: self class name, ' new'.
	aStream nextPutAll: (String cr, String tab, String tab).
	1 to: self class instSize do:
		[:i |
		(self instVarAt: i) ifNotNil: [
			aStream nextPutAll: (' ',(self class allInstVarNames at: i),': ');
				store: (self instVarAt: i);
				nextPut: $;;
				nextPutAll: (String cr, String tab, String tab)
			]
		].
	1 to: self basicSize do:
		[:i |
		aStream nextPutAll: ' basicAt: ';
			store: i;
			nextPutAll: ' put: ';
			store: (self basicAt: i);
			nextPut: $;].
	aStream nextPutAll: ' yourself)'.! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
updateActions
	^ updateActions! !

!SqSForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
updateActions: anObject
	updateActions := anObject! !

Object subclass: #SqSMagritteDescriptionCreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSMagritteDescriptionCreator methodsFor: 'as yet unclassified' stamp: 'tk 8/31/2008 15:16'!
createDescriptorNamed: aSelector for: anObject withLabel: aLabel inClass: aClass
	| code |
	code := aSelector,String cr,(self descriptorCodeFor: aLabel basedOn: anObject),String cr.
	self compileMethodCode: code intoClass: aClass.
	! !

!SqSMagritteDescriptionCreator methodsFor: 'as yet unclassified' stamp: 'tk 8/31/2008 15:16'!
descriptionCodeFor: anObject labeled: aLabel withClass: className
	| code |
	code := String tab,'^',className asString,' new', (self indent: 2).
	code := code, 'selectorAccessor: #', aLabel, ';',(self indent: 2).
	code := code, 'label: ''', aLabel,''';',(self indent: 2).
	(anObject respondsTo: #magritteDescriptionDefaultValue) ifTrue: [
		code := code, 'default: ', anObject magritteDescriptionDefaultValue, ';', (self indent: 2). 	
	].
	code := code, 'yourself'.
	^code! !

!SqSMagritteDescriptionCreator methodsFor: 'as yet unclassified' stamp: 'tk 9/2/2008 15:18'!
descriptorCodeFor: aLabel basedOn: anObject 
	| className code |
	className := anObject class name.
	(anObject respondsTo: #magritteDescriptionClass) 
		ifTrue: 
			[ code := self 
				descriptionCodeFor: anObject
				labeled: aLabel
				withClass: anObject magritteDescriptionClass ]
		ifFalse: 
			[ (anObject class inheritsFrom: Collection) 
				ifTrue: 
					[ code := self 
						descriptionCodeFor: anObject
						labeled: aLabel
						withClass: #MAToManyRelationDescription ]
				ifFalse: 
					[ (anObject class inheritsFrom: SqSBase) ifTrue: 
						[ code := self 
							descriptionCodeFor: anObject
							labeled: aLabel
							withClass: #MAToOneRelationDescription ] ] ].
	^ code! !

Object subclass: #SqSPersistenceDescription
	instanceVariableNames: 'associatedClass manuallyMaintained'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

SqSPersistenceDescription subclass: #SqSCollectionDescription
	instanceVariableNames: 'collectionClass joinTableName ownerColumn referenceColumn referenceTableName includedClass maintainOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 14:45'!
collectionClass
	^ collectionClass! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 14:45'!
collectionClass: anObject
	collectionClass := anObject! !

!SqSCollectionDescription methodsFor: 'as yet unclassified' stamp: 'tk 7/23/2008 15:13'!
describesCollection
	^true! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/12/2008 16:58'!
includedClass
	^ includedClass! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/12/2008 16:58'!
includedClass: anObject
	includedClass := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
joinTableName
	^ joinTableName! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
joinTableName: anObject
	joinTableName := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:14'!
maintainOrder
	^ maintainOrder! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:14'!
maintainOrder: anObject 
	maintainOrder := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
ownerColumn
	^ ownerColumn! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
ownerColumn: anObject
	ownerColumn := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceColumn
	^ referenceColumn! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceColumn: anObject
	referenceColumn := anObject! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceTableName
	^ referenceTableName! !

!SqSCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceTableName: anObject
	referenceTableName := anObject! !

SqSPersistenceDescription subclass: #SqSColumnDescription
	instanceVariableNames: 'columnName sqlType objectClass tableName foreignKey canBeNull isPrimaryKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:39'!
canBeNull
	^ canBeNull! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:39'!
canBeNull: anObject
	canBeNull := anObject! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:39'!
columnName
	^ columnName! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:39'!
columnName: anObject
	columnName := anObject! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:58'!
foreignKey
	^ foreignKey! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:16'!
foreignKey: anObject
	foreignKey := anObject.
	"being a foreign key, the column can not be null"
	self canBeNull: false.! !

!SqSColumnDescription methodsFor: 'as yet unclassified' stamp: 'tk 8/14/2008 13:41'!
initialize
	super initialize.
	self canBeNull: true.
	self isPrimaryKey: false.! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 8/14/2008 11:56'!
isPrimaryKey
	^ isPrimaryKey! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 8/14/2008 11:56'!
isPrimaryKey: anObject
	isPrimaryKey := anObject! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 6/19/2008 15:59'!
objectClass
	^ objectClass! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 6/19/2008 15:59'!
objectClass: anObject
	objectClass := anObject! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType
	^ sqlType! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType: anObject
	sqlType := anObject! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 7/4/2008 16:18'!
tableName
	^ tableName! !

!SqSColumnDescription methodsFor: 'accessing' stamp: 'tk 7/4/2008 16:18'!
tableName: anObject
	tableName := anObject! !

!SqSPersistenceDescription methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 16:16'!
adaptObject: anObject
	self associatedClass ifNil: [
		^anObject	
	] ifNotNil: [
		^(Smalltalk at: (self associatedClass asSymbol)) findByOid: anObject 
	]! !

!SqSPersistenceDescription methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass
	^ associatedClass! !

!SqSPersistenceDescription methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass: anObject
	associatedClass := anObject! !

!SqSPersistenceDescription methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 14:44'!
creationCode
	| aStream |
	aStream := TextStream on: String new.

	aStream nextPut: $(.
	aStream nextPutAll: self class name, ' new'.
	aStream nextPutAll: (String cr, String tab).
	1 to: self class instSize do:
		[:i |
		(self instVarAt: i) ifNotNil: [
			aStream 
				nextPutAll: (String cr, String tab);
				nextPutAll: (' ',(self class allInstVarNames at: i),': ');
				store: (self instVarAt: i);
				nextPut: $;
			]
		].
	1 to: self basicSize do:
		[:i |
		aStream nextPutAll: ' basicAt: ';
			store: i;
			nextPutAll: ' put: ';
			store: (self basicAt: i);
			nextPut: $;].
	aStream nextPutAll: ' yourself)'.
	^aStream contents
	! !

!SqSPersistenceDescription methodsFor: 'as yet unclassified' stamp: 'tk 7/23/2008 15:12'!
describesCollection
	^false! !

!SqSPersistenceDescription methodsFor: 'as yet unclassified' stamp: 'tk 8/15/2008 16:37'!
initialize
	super initialize.
	self manuallyMaintained: false.! !

!SqSPersistenceDescription methodsFor: 'accessing' stamp: 'tk 8/15/2008 16:38'!
manuallyMaintained
	^ manuallyMaintained! !

!SqSPersistenceDescription methodsFor: 'accessing' stamp: 'tk 8/15/2008 16:38'!
manuallyMaintained: anObject
	manuallyMaintained := anObject! !

!SqSPersistenceDescription methodsFor: 'as yet unclassified' stamp: 'tk 8/5/2008 18:58'!
storeOn: aStream
	aStream nextPutAll: self creationCode! !

Object subclass: #SqSProxyObject
	instanceVariableNames: 'proxiedVariable targetObject actualObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSProxyObject class methodsFor: 'as yet unclassified' stamp: 'tk 8/12/2008 13:23'!
forAttribute: ivarName ofClass: aClass
	^(self new
		proxiedVariable: ivarName;
		targetClass: aClass;
		yourself)! !

!SqSProxyObject class methodsFor: 'as yet unclassified' stamp: 'tk 8/12/2008 15:43'!
forAttribute: ivarName ofObject: aClass
	^(self new
		proxiedVariable: ivarName;
		targetObject: aClass;
		yourself)! !

!SqSProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 15:42'!
actualObject
	^ actualObject! !

!SqSProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 15:42'!
actualObject: anObject
	actualObject := anObject! !

!SqSProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 13:21'!
proxiedVariable
	^ proxiedVariable! !

!SqSProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 13:21'!
proxiedVariable: anObject
	proxiedVariable := anObject! !

!SqSProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 15:42'!
targetObject
	^ targetObject! !

!SqSProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 15:42'!
targetObject: anObject
	targetObject := anObject! !

Object subclass: #SqSTableStructureHandler
	instanceVariableNames: 'currentObject'
	classVariableNames: 'TableCache'
	poolDictionaries: ''
	category: 'TKSave-Base'!

SqSTableStructureHandler subclass: #SqSClassTableInheritanceTableStructureHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
buildSearchFor: instVars withValues: values 
	| descrHandler searchDict descr targetClass baseClass typeField tableName columnName |
	descrHandler := self currentObject descriptionHandler.
	targetClass := self currentObject class.
	searchDict := Dictionary new.
	baseClass := targetClass baseClass.
	typeField := targetClass sqSaveConnection class inheritanceTypeField.
	instVars withIndexDo: 
		[ :ivar :index | 
		ivar = 'oid' 
			ifTrue: 
				[ tableName := baseClass tableName.
				columnName := 'oid' ]
			ifFalse: 
				[ descr := descrHandler columnDescriptionFor: ivar.
				tableName := descr tableName.
				columnName := descr columnName ].
		(searchDict 
			at: tableName
			ifAbsentPut: Dictionary new) 
			at: #AND
			ifAbsentPut: Set new.
		((searchDict at: tableName) at: #AND) add: columnName -> (values at: index) ].
	(searchDict 
		at: baseClass tableName
		ifAbsentPut: Dictionary new) 
		at: #OR
		ifAbsentPut: Set new.
	((searchDict at: baseClass tableName) at: #OR) add: typeField -> targetClass name.
	targetClass allSubclasses do: [ :sc | ((searchDict at: baseClass tableName) at: #OR) add: typeField -> sc name ].
	[ targetClass ~= baseClass ] whileTrue: 
		[ searchDict 
			at: targetClass tableName
			ifAbsentPut: Dictionary new.
		targetClass := targetClass superclass ].
	^ searchDict! !

!SqSClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:05'!
createColumnDictionaries
	| baseClass columnDict klass columns infoDict |
	columns := OrderedCollection new.
	baseClass := self currentObject class baseClass.
	infoDict := Dictionary new.
	infoDict 
		at: #tableName
		put: baseClass tableName.
	columnDict := Dictionary new.
	baseClass allClassTableColumns associationsDo: 
		[ :assoc | 
		columnDict 
			at: assoc value columnName
			put: (self currentObject escapedValueForInstanceVariable: assoc key) ].
	infoDict 
		at: #columns
		put: columnDict.
	columns add: infoDict.
	klass := self currentObject class.
	[ klass ~= baseClass ] whileTrue: 
		[ infoDict := Dictionary new.
		infoDict 
			at: #tableName
			put: klass tableName.
		columnDict := Dictionary new.
		klass allClassTableColumns associationsDo: 
			[ :assoc | 
			columnDict 
				at: assoc value columnName
				put: (self currentObject escapedValueForInstanceVariable: assoc key) ].
		infoDict 
			at: #columns
			put: columnDict.
		columns add: infoDict.
		klass := klass superclass ].
	^ columns! !

!SqSClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:19'!
createSpecificTableStructure
	| sampleClass connection lightOidColumn columnDict baseClass |
	sampleClass := self currentObject class.
	baseClass := sampleClass baseClass.
	connection := sampleClass sqSaveConnection.

	"this oid column is lacking the auto increment feature, since this has to be set manually"
	"however we need a foreign key constraint to simplify maintaining  data integrity between the tables"
	lightOidColumn := SqSColumnDescription new
		columnName: 'oid';
		sqlType: connection integer;
		canBeNull: false;
		isPrimaryKey: true;
		foreignKey: (SqSForeignKeyDescription new
				referencedColumns: #('oid' );
				deleteActions: #(#CASCADE );
				referencedTable: baseClass tableName).

	"create the base class table first, if it does not already exist"
	baseClass tableForClassExists ifFalse: 
		[ connection executeQuery: (connection 
				queryToCreateTableNamed: baseClass tableName
				withColumns: baseClass allClassTableColumns) ].
	(TableCache at: baseClass name) 
		at: baseClass tableName
		put: baseClass allClassTableColumns.

	"the create all other tables in the hierarchy"
	[ sampleClass = baseClass ] whileFalse: 
		[ sampleClass tableForClassExists ifFalse: 
			[ columnDict := sampleClass allClassTableColumns.
			columnDict 
				at: 'oid'
				put: lightOidColumn.
			connection executeQuery: (connection 
					queryToCreateTableNamed: sampleClass tableName
					withColumns: columnDict) ].
		(TableCache at: baseClass name) 
			at: sampleClass tableName
			put: sampleClass allClassTableColumns.
		sampleClass := sampleClass superclass ]! !

!SqSClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
deleteObject
	"this is were the beauty of foreign key constraints kicks in - just delete the object in the base table"
	^ self currentObject class sqSaveConnection 
		removeObjectWithId: self currentObject oid
		fromTable: self currentObject class baseClass tableName! !

!SqSClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 15:12'!
insertCurrentObject
	| connection baseClass columnDict lastOid klass |
	connection := self currentObject class sqSaveConnection.
	baseClass := self currentObject class baseClass.
	columnDict := Dictionary new.
	baseClass allClassTableColumns associationsDo: 
		[ :assoc | 
		columnDict 
			at: assoc value columnName
			put: (self currentObject escapedValueForInstanceVariable: assoc key) ].
	connection inTransactionDo: 
		[ lastOid := connection 
			storeColumns: columnDict
			inTable: baseClass tableName
			andReturnOId: true.
		klass := self currentObject class.
		[ klass ~= baseClass ] whileTrue: 
			[ columnDict := Dictionary new.
			klass allClassTableColumns associationsDo: 
				[ :assoc | 
				columnDict 
					at: assoc value columnName
					put: (self currentObject escapedValueForInstanceVariable: assoc key) ].
			columnDict 
				at: 'oid'
				put: lastOid.
			connection 
				storeColumns: columnDict
				inTable: klass tableName.
			klass := klass superclass ] ].
	^ lastOid! !

SqSTableStructureHandler subclass: #SqSSingleTableInheritanceTableStructureHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
buildSearchFor: instVars withValues: values 
	| descrHandler searchDict descr targetClass baseClass typeField tableName columnName |
	descrHandler := self currentObject descriptionHandler.
	targetClass := self currentObject class.
	searchDict := Dictionary new.
	baseClass := targetClass baseClass.
	typeField := targetClass sqSaveConnection class inheritanceTypeField.
	instVars withIndexDo: 
		[ :ivar :index | 
		ivar = 'oid' 
			ifTrue: 
				[ tableName := baseClass tableName.
				columnName := 'oid' ]
			ifFalse: 
				[ descr := descrHandler columnDescriptionFor: ivar.
				tableName := descr tableName.
				columnName := descr columnName ].
		(searchDict 
			at: tableName
			ifAbsentPut: Dictionary new) 
			at: #AND
			ifAbsentPut: Set new.
		((searchDict at: tableName) at: #AND) add: columnName -> (values at: index) ].
	(searchDict 
		at: baseClass tableName
		ifAbsentPut: Dictionary new) 
		at: #OR
		ifAbsentPut: Set new.
	((searchDict at: baseClass tableName) at: #OR) add: typeField -> targetClass name.
	targetClass allSubclasses do: [ :sc | ((searchDict at: baseClass tableName) at: #OR) add: typeField -> sc name ].
	^ searchDict! !

!SqSSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:05'!
createColumnDictionaries
	| columnDict infoDict |
	columnDict := Dictionary new.
	self currentObject class allClassTableColumns associationsDo: 
		[ :assoc | 
		columnDict 
			at: assoc value columnName
			put: (self currentObject escapedValueForInstanceVariable: assoc key) ].
	infoDict := Dictionary newFrom: { 
			(#tableName -> self currentObject class tableName).
			(#columns -> columnDict)
		 }.
	^ OrderedCollection with: infoDict! !

!SqSSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
createSpecificTableStructure
	| connection columnDictionary sampleClass |
	sampleClass := self currentObject class.
	connection := self currentObject sqSaveConnection.
	columnDictionary := self currentObject allClassTableColumns.
	(TableCache at: sampleClass baseClass name) 
		at: sampleClass tableName
		put: columnDictionary.
	connection executeQuery: (connection 
			queryToCreateTableNamed: sampleClass tableName
			withColumns: columnDictionary)! !

!SqSSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
deleteObject
	^ self currentObject sqSaveConnection 
		removeObjectWithId: self currentObject oid
		fromTable: self currentObject class tableName! !

!SqSSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 15:12'!
insertCurrentObject
	| columnDict connection |
	columnDict := Dictionary new.
	connection := self currentObject sqSaveConnection.
	self currentObject allClassTableColumns associationsDo: 
		[ :assoc | 
		columnDict 
			at: assoc value columnName
			put: (self currentObject escapedValueForInstanceVariable: assoc key) ].
	^ connection 
		storeColumns: columnDict
		inTable: self currentObject tableName
		andReturnOId: true! !

!SqSTableStructureHandler class methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:26'!
for: anObject 
	"determine the proper structure handler class"
	| inheritanceMode targetClass |
	inheritanceMode := anObject class descriptionHandler inheritanceModeForClass: anObject class.
	targetClass := 'SqS' , inheritanceMode capitalized , 'TableStructureHandler'.
	targetClass := Smalltalk
				at: targetClass asSymbol
				ifAbsent: [self error: 'Unknown inheritance Mode'].
	"initialize the table cache (if not already done...)"
	TableCache
		ifNil: [TableCache := Dictionary new].
	"and return a completely new handler"
	^ targetClass new currentObject: anObject;
		 yourself! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 17:07'!
buildSearchFor: instVars withValues: values
	self subclassResponsibility! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/17/2008 16:15'!
createColumnDictionaries
	self subclassResponsibility! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
createJoinTableFromDescription: reference 
	| referenceColumn ownerColumn columns descr |
	descr := reference at: #description.
	referenceColumn := descr referenceColumn.
	ownerColumn := descr ownerColumn.
	columns := OrderedCollection 
		with: ownerColumn
		with: referenceColumn.
	self currentObject sqSaveConnection 
		createJoinTableNamed: descr joinTableName
		withColumns: columns
		andOrderField: descr maintainOrder.
	self insertJoinTableDescriptionToCache: reference! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/14/2008 11:51'!
createSpecificTableStructure
	^self subclassResponsibility! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:05'!
createTableStructure
	"reinitialize the table cache, since we are recreating the structure"
	TableCache 
		at: self currentObject class name
		put: Dictionary new.
	self createSpecificTableStructure.
	self currentObject indirectlyReferencedObjects do: [ :reference | self createJoinTableFromDescription: reference ]! !

!SqSTableStructureHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:05'!
currentObject
	^ currentObject! !

!SqSTableStructureHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:04'!
currentObject: anObject 
	currentObject := anObject! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/12/2008 17:35'!
deleteObject
	^self subclassResponsibility! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:49'!
findChangedColumnsInJoinTable: aDescr ofClass: aClass
	| oldDescription changedColumns descr |
	descr := aDescr at: #description.
	
	oldDescription := ((TableCache at: aClass name) at: descr joinTableName).
	
	changedColumns := Dictionary new.	
	(oldDescription ownerColumn columnName ~= descr ownerColumn columnName) ifTrue: [
		changedColumns at: #renamed put: descr ownerColumn	
	].

	(oldDescription referenceColumn columnName ~= descr referenceColumn columnName) ifTrue: [
		changedColumns at: #renamed put: descr referenceColumn	
	].

	(oldDescription ownerColumn sqlType ~= descr ownerColumn sqlType) ifTrue: [
		changedColumns at: #altered put: descr ownerColumn	
	].

	(oldDescription referenceColumn sqlType ~= descr referenceColumn sqlType) ifTrue: [
		changedColumns at: #altered put: descr referenceColumn	
	].
	
	"finally set up the table cache at the corresponding entry..."
	(TableCache at: aClass name) at: descr joinTableName put: descr.

	^changedColumns


	! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 14:28'!
findChangesInClass: aClass storeIn: changedColumns
	| curColumns oldColumns curCol prevCol |
	curColumns := aClass allClassTableColumns.
	oldColumns := (TableCache at: aClass baseClass name) 
		at: aClass tableName
		ifAbsent: [ Dictionary new ].
	oldColumns associationsDo: [ :assoc | 
		curCol := curColumns at: assoc key.
		prevCol := assoc value.
		"if we can't find the current column for an old one it has been deleted'"
		curCol 
			ifNil: [ (changedColumns at: #deleted) add: prevCol ]
			ifNotNil: [ 
				"if the name's different, add it to changed'"
				curCol columnName ~= prevCol columnName ifTrue: [ 
					(changedColumns at: #renamed) add: (OrderedCollection 
						with: prevCol
						with: curCol)
				].
				"same for sql type"
				(curCol sqlType ~= prevCol sqlType and: [ curCol sqlType isNil not ]) ifTrue: [ (changedColumns at: #altered) add: curCol ] 
			] 
	].
	"and now find the columns that have been added"
	(changedColumns at: #added) addAll: (curColumns associationsSelect: [ :assoc | (oldColumns includesKey: assoc key) not ]) values.
	! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 15:48'!
getChangedColumns

	| baseClass joinChanges descr |
	baseClass := self currentObject class baseClass.
	joinChanges := Dictionary new.
	self currentObject indirectlyReferencedObjects do: 
		[ :reference | 
		descr := reference at: #description.
		((TableCache at: baseClass name) includesKey: descr joinTableName) 
			ifTrue: 
				[ joinChanges valueJoin: (self 
						findChangedColumnsInJoinTable: reference
						ofClass: baseClass) ]
			ifFalse: [ self createJoinTableFromDescription: reference ] ].
	^ joinChanges valueJoin: self getStructureSpecificChangedColumns! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 9/2/2008 15:18'!
getStructureSpecificChangedColumns
	| currentClass changedColumns baseClass |
	currentClass := self currentObject class.
	baseClass := currentClass baseClass.
	changedColumns := Dictionary newFrom: { 
			(#renamed -> Set new).
			(#deleted -> Set new).
			(#altered -> Set new).
			(#added -> Set new)
		 }.
	[ currentClass ~= SqSBase ] whileTrue: 
		[ self 
			findChangesInClass: currentClass
			storeIn: changedColumns.
		currentClass := currentClass superclass ].
	^ changedColumns! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 15:12'!
insertCurrentObject
	self subclassResponsibility! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:58'!
insertJoinTableDescriptionToCache: reference 
	| descr |
	descr := reference at: #description.
	(TableCache at: self currentObject class baseClass name) 
		at: descr joinTableName
		put: descr! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 18:23'!
insertObject
	| |
	"first store all objects that are directly referenced by the main object - i.e. one-to-one relations"
	self currentObject directlyReferencedObjects do: [ :obj | obj save ].

	"next store the object itself"
	self currentObject oid: (self insertCurrentObject).

	"store all objects the sample object holds within one-to-many associations - they explicitly need the oid"
	self insertOwnedCollections.! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:20'!
insertOwnedCollections
	| columnDict connection collectionDescription counter proxy |
	columnDict := Dictionary new.
	connection := self currentObject sqSaveConnection.
	self currentObject indirectlyReferencedObjects do: 
		[ :reference | 
		collectionDescription := reference at: #description.
		counter := 1.
		(reference at: #collection) do: 
			[ :obj | 
			obj ifNotNil: [ obj save ].
			columnDict := Dictionary new.
			columnDict 
				at: collectionDescription referenceColumn columnName
				put: (obj 
						ifNil: [ connection class nilValue ]
						ifNotNil: [ obj oid ]).
			columnDict 
				at: collectionDescription ownerColumn columnName
				put: self currentObject oid.
			collectionDescription maintainOrder ifTrue: 
				[ columnDict 
					at: connection class collectionOrderField
					put: counter ].
			counter := counter + 1.
			connection 
				storeColumns: columnDict
				inTable: collectionDescription joinTableName ].
		"this could be bad...many side-effects possible - better use some method of our own"
		proxy := SqSCollectionProxy 
			for: (reference at: #collection)
			ofInstVar: (reference at: #variable)
			in: self currentObject.
		self currentObject 
			setInstVarNamed: (reference at: #variable)
			withValue: proxy ]! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
loadProxiedObjectOfVariable: ivarName 
	| descr connection collectionElements |
	descr := self currentObject descriptionHandler columnDescriptionFor: ivarName.
	connection := self currentObject sqSaveConnection.
	collectionElements := connection 
		getCollectionDescribedBy: descr
		forObjectId: self currentObject oid.
	^ descr collectionClass withAll: collectionElements! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/29/2008 15:41'!
storeCollectionChanges: changesDictionary withDescription: aDescription
	| connection oid |
	connection := self currentObject sqSaveConnection.
	oid := self currentObject oid.
	(changesDictionary at: #deleted) ifNotEmpty: [
		connection removeEntries: (changesDictionary at: #deleted) fromJoinTable: aDescription forOwnerId: oid.
	].

	"only move the Entries if the order is important"
	(((changesDictionary at: #moved) isEmpty not) and: [aDescription maintainOrder]) ifTrue: [
		connection moveEntries: (changesDictionary at: #moved) inJoinTable: aDescription forOwnerId: oid.	
	].

	(changesDictionary at: #added) ifNotEmpty: [
		connection addEntries: (changesDictionary at: #added) inJoinTable: aDescription forOwnerId: oid.	
	].

! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 14:59'!
updateObject
	| columnDicts connection |
	"store all directly associated objects right now"
	self currentObject directlyReferencedObjects do: [:obj | obj save].
	
	columnDicts := self createColumnDictionaries.
	connection := self currentObject sqSaveConnection.
	columnDicts do: 
		[ :columnDict | 
		connection inTransactionDo: 
			[ connection 
				updateFields: (columnDict at: #columns)
				ofObjectWithId: self currentObject oid
				inTable: (columnDict at: #tableName) ] ].
		
	self updateOwnedCollections.
	
	! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tkow 9/2/2008 16:20'!
updateOwnedCollections
	| proxy oldCollection tmpProxy colChanges |
	self currentObject indirectlyReferencedObjects do: 
		[ :reference | 
		"this object should always be an SqSaveCollectionProxy that 
		knows how the object looked like at the last save"
		proxy := reference at: #collection.
		proxy do: [ :collectionObj | collectionObj ifNotNil: [ collectionObj save ] ].
		"someone replaced the former collection with an entirely new one"
		proxy class = SqSCollectionProxy ifFalse: 
			[ oldCollection := self loadProxiedObjectOfVariable: (reference at: #variable).
			tmpProxy := SqSCollectionProxy 
				for: oldCollection
				ofInstVar: (reference at: #variable)
				in: self currentObject.
			tmpProxy proxiedObject: proxy.
			proxy := tmpProxy ].
		colChanges := proxy getCollectionChanges.
		self 
			storeCollectionChanges: colChanges
			withDescription: (reference at: #description) ]! !

!SqSTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
updateTableStructure
	| structureChanges connection |
	structureChanges := self getChangedColumns.
	connection := self currentObject sqSaveConnection.
	"first rename the columns that need renaming"
	connection renameColumns: (structureChanges at: #renamed).
	"then alter the ones that need to be altered (sql whise)"
	connection alterColumns: (structureChanges at: #altered).
	"delete..."
	connection removeColumns: (structureChanges at: #deleted).
	"add..."
	connection addColumns: (structureChanges at: #added)! !

!Number methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:45'!
magritteDescriptionClass
	^#MANumberDescription! !

!Number methodsFor: '*tksave' stamp: 'tk 5/21/2008 11:10'!
magritteDescriptionDefaultValue
	^'0'! !

!Number methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:45'!
magritteDescriptionStandardValue
	^0! !

!Date methodsFor: '*tksave' stamp: 'tk 5/21/2008 11:20'!
magritteDescriptionClass
	^#MADateDescription! !

!Date methodsFor: '*tksave' stamp: 'tk 5/21/2008 11:20'!
magritteDescriptionDefaultValue
	^'Date today'! !

!Dictionary methodsFor: '*tksave' stamp: 'tk 8/15/2008 14:55'!
valueJoin: anotherDictionary
	"really joins two dictionaries with collections as values"
	| ownValue mergeValue |
	anotherDictionary associationsDo: [ :assoc |
		(self includesKey: assoc key) ifTrue: [
			ownValue := (self at: assoc key) isCollection ifTrue:[
				self at: assoc key
			] ifFalse: [
				OrderedCollection with: (self at: assoc key)
			].
			mergeValue := (assoc value) isCollection ifTrue:[
				assoc value
			] ifFalse: [
				OrderedCollection with: (assoc value).
			].
			self at: assoc key put: (ownValue union: mergeValue).
		] ifFalse: [
			self at: assoc key put: assoc value
		]
	].
	^self! !
